#ifdef  __COMMUNICATE
#define FUNDEF extern "C" __declspec(dllexport)
#else
#define FUNDEF extern "C" __declspec(dllimport)
#endif
#define STDCALL _stdcall

//===== Open the communicate entry =====//
//  nPortType:  1 --> Serial port
//  nPort:      Port number
//  pName:	    The port name
//  Example:
//      Com3:     OpenCom_Entry(1, 3, NULL);
FUNDEF HANDLE STDCALL OpenCom_Entry(int nPortType, int nPort, LPSTR pName = NULL);

//===== Close the communicate entry =====//
FUNDEF int STDCALL CloseCom_Entry(HANDLE hPort);
FUNDEF void STDCALL CloseAllCom_Entry();

//===== Set serial port setting =====//
FUNDEF int STDCALL SetSerial(HANDLE hPort, int nBaudRate = 0, int nByteSize = 0, int nParity = 0,
			int nStopBits = 0, int nFlowCtrl = 0);

//===== Writes data to communicate port =====//
FUNDEF int STDCALL WriteCom_Entry(HANDLE hPort, int nDataLen, LPTSTR pData);

//===== Reads data from Communicate port =====//
FUNDEF int STDCALL ReadCom_Entry(HANDLE hPort, LPTSTR pData, int nMaxLength);
FUNDEF int STDCALL PurgeCom(HANDLE hPort);
FUNDEF int STDCALL SetReadBuffer(HANDLE hPort, int nSize);

//===== USB Communicate port =====//
FUNDEF int STDCALL EnumUSB();
FUNDEF int STDCALL GetUSBNameMaxLen();
FUNDEF int STDCALL GetUSBName(int nPort, LPTSTR pData, int *nBufferMax);

//================ Handle the commincate status ================//
//    Handle to an event set to the signaled state when the     //  
//    operation has been completed. The calling process must    //
//    set this member either to zero or a valid event handle    //
//    before calling any overlapped functions. To create an     //
//    event                                                     //
FUNDEF int STDCALL SetReadEvent(HANDLE hPort, HANDLE hWatchRead);

//==== Other function ====//
FUNDEF int STDCALL GetError();
FUNDEF int STDCALL GetCommVer(char *pVer);
