#ifdef  __PROTOCOL
#define PROFUN extern "C" __declspec(dllexport)
#else
#define PROFUN extern "C" __declspec(dllimport)
#endif
#define STDCALL _stdcall

//===== Open the communicate port =====//
//  nPortType:  1 --> Serial port, 2 --> USB
//  nPort:      Port number
//  pName:	    The port name
//  Example:
//      Com3:     OpenCom_Entry(1, 3, NULL);
PROFUN HANDLE STDCALL PT_OpenPort(int nPortType, int nPort, LPSTR pName = NULL, int nBaudRate = 0,
			int nByteSize = 0, int nParity = 0, int nStopBits = 0, int nFlowCtrl = 0);
PROFUN int STDCALL PT_EnumUSB();
PROFUN int STDCALL PT_GetUSBNameMaxLen();
PROFUN int STDCALL PT_GetUSBName(int nPort, LPTSTR pData, int *nBufferMax);

//===== Close the communicate port =====//
PROFUN int STDCALL PT_ClosePort(HANDLE hPort);
PROFUN void STDCALL PT_CloseAllPort();

//===== File Transfer =====//
PROFUN int STDCALL PT_DownloadFile(HANDLE hPort, LPTSTR pPCSource, LPTSTR pPTDest, int nFlag,
						int nShowProcess);
PROFUN int STDCALL PT_DownloadMultiFile(HANDLE hPort, LPTSTR pPCSource, LPTSTR pPTDest,
						int nFlag, int nMaxFile, int nFileIndex, int nShowProcess);
PROFUN int STDCALL PT_GetPDTFile(HANDLE hPort, LPTSTR strSource, LPTSTR strDest, int nShowProcess);
PROFUN int STDCALL PT_DownloadApplication(HANDLE hPort, LPTSTR FWfile, int nShowProcess);

PROFUN int STDCALL PT_DirFile(HANDLE hPort, LPTSTR pFolder, int *pnItems, LPTSTR pData, int *pnMaxBuf);
PROFUN int STDCALL PT_DeleteFile(HANDLE hPort, LPTSTR strFile);
PROFUN int STDCALL PT_FormatDisk(HANDLE hPort, LPTSTR strDisk);
PROFUN int STDCALL PT_GetDiskInfo(HANDLE hPort, LPTSTR strDisk, LONG &lTotal, LONG &lUsed, 
						LONG &lFree);
PROFUN int STDCALL PT_SetTime(HANDLE hPort, char Time[14]);
PROFUN int STDCALL PT_GetPDTInformation(HANDLE hPort, char PDTName[10], char FWVer[10],
						char SN[20], char EquipID[20]);

//===== Encryption function =====//
PROFUN int STDCALL PT_EncryptFile(LPTSTR strSource, LPTSTR strNewFile = NULL);
PROFUN int STDCALL PT_DownloadEncryptFile(HANDLE hPort, LPTSTR pPCSource, int nPTDest, int nFlag,
						int nShowProcess);

//===== Convert function =====//
PROFUN int STDCALL PT_ConvertFile(LPTSTR strSource, LPTSTR strNewFile, char cOriDeli, LPCSTR strOriFieldData,
						unsigned int uConvFieldCount, char cConvDeli, LPCSTR strConvFieldData);

//===== Other function =====//
PROFUN int STDCALL PT_SetAgentID(HANDLE hPort, LPTSTR UserID, LPTSTR Password);
PROFUN int STDCALL GetPTProtocolVersion(char *pVersion);
PROFUN int STDCALL PT_GetErrorCode();
