// ComTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ComTest.h"
#include "ComTestDlg.h"
#include "ComPort.h"
#include "ComSetting.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CFile	g_f;

void ReadThread(CComTestDlg *dlg)
{
	CString strTemp, strText;
	char	pReadBuf[1024];
	int		nRead;

	do{
		if(dlg->m_hWatchEvent && WaitForSingleObject(dlg->m_hWatchEvent, INFINITE) == WAIT_OBJECT_0){
			memset(pReadBuf, 0, 1024);
			nRead = ReadCom_Entry(dlg->m_hPort, pReadBuf, 1024);
			if(nRead){
				g_f.Write(pReadBuf, nRead);
				//dlg->m_editRead.GetWindowText(strText);
				//strText += strTemp;
				//dlg->m_editRead.SetWindowText(strText);
			}
			//else{
			//	strTemp.Format("WriteCom_Entry Error:%d", GetError());
			//	AfxMessageBox(strTemp);
			//}
		}
	}while(1);
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComTestDlg dialog

CComTestDlg::CComTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CComTestDlg::IDD, pParent)
{
	m_bConnect = FALSE;
	m_hPort = m_hWatchEvent = m_hThread = NULL;
	m_nBaud = m_nDataBits = m_nParity = m_nFlowCtrl = 0;

	//{{AFX_DATA_INIT(CComTestDlg)
	m_strWrite = _T("");
	m_strPortMess = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CComTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CComTestDlg)
	DDX_Control(pDX, IDC_COMBO_PORT, m_ctrlPort);
	DDX_Control(pDX, IDC_EDIT_READ, m_editRead);
	DDX_Text(pDX, IDC_EDIT_WRITE, m_strWrite);
	DDX_Text(pDX, IDC_EDIT_MESS, m_strPortMess);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CComTestDlg, CDialog)
	//{{AFX_MSG_MAP(CComTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_CONNECT, OnBtnConnect)
	ON_EN_CHANGE(IDC_EDIT_WRITE, OnChangeEditWrite)
	ON_CBN_SELCHANGE(IDC_COMBO_PORT, OnSelchangeComboPort)
	ON_BN_CLICKED(IDC_BTN_TRANSFILE, OnBtnTransfile)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BTN_PORTSETTING, OnBtnPortsetting)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComTestDlg message handlers

BOOL CComTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	/*CFile f;
	char	temp[500];
	int		a;

	memset(temp, 0, 500);
	for(a = 0 ; a < 127 ; a++)
		temp[a] = a;

	f.Open("C:\\SD.txt", CFile::modeCreate|CFile::modeWrite);
	for(a = 0 ; a < 4100 ; a++){
		f.Write(temp, 127);
		f.Write("\r\n", 2);
	}
	f.Close();*/

	// Add "About..." menu item to system menu.
	CString strTemp;
	char	Ver[20];

	GetWindowText(strTemp);
	GetCommVer(Ver);
	strTemp += "-";
	strTemp += Ver;
	SetWindowText(strTemp);
	
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	DWORD	i, dwValue;
	char	*name;
	int nMax, nError;

	name = (char *) new char[100];
	dwValue = EnumUSB();
	for(i = 0 ; i < dwValue ; i++){
		nMax = GetUSBNameMaxLen();
		if(nMax > 100){
			delete name;
			name = new char[nMax];
		}

		nError = GetUSBName(i, name, &nMax);
		if(nError){
			strTemp.Format("Error: %d", nError);
			AfxMessageBox(strTemp);
		}
		else{
			strTemp.Format("%s", name);
			m_ctrlPort.AddString(strTemp);
		}
	}
	
	m_ctrlPort.SetCurSel(0);
	UpdateMess();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CComTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CComTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CComTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CComTestDlg::OnBtnConnect() 
{
	int nPort, nPortType, nError;
	CString strTemp, strPort;
	
	UpdateData();
	GetDlgItem(IDC_COMBO_PORT)->EnableWindow(TRUE);
	GetDlgItem(IDC_BTN_PORTSETTING)->EnableWindow(TRUE);
	GetDlgItem(IDC_BTN_CONNECT)->SetWindowText("Connect");

	if(m_bConnect){
		nError = CloseCom_Entry(m_hPort);
		if(nError){
			strTemp.Format("Error: %d", nError);
			AfxMessageBox(strTemp);
		}
		CloseHandle(m_hWatchEvent);
		CloseHandle(m_hThread);
		m_hPort = m_hWatchEvent = m_hThread = NULL;
		m_bConnect = FALSE;
		g_f.Close();
	}
	else{
		nPort = m_ctrlPort.GetCurSel();
		if(nPort >= 4){
			nPortType = 2;
			nPort -= 3;
		}
		else{
			m_ctrlPort.GetWindowText(strPort);
			nPortType = 1;
			strTemp = strPort.Right(strPort.GetLength() - 3);
			nPort = atoi(strTemp.LockBuffer());
			strTemp.UnlockBuffer();
		}
		
		m_hPort = OpenCom_Entry(nPortType, nPort, NULL);

		if(m_hPort){
			SetReadBuffer(m_hPort, 4096);
			m_hWatchEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
			nError = SetReadBuffer(m_hWatchEvent, 4096);
			SetReadEvent(m_hPort, m_hWatchEvent);
			m_hThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) ReadThread, this, 0, &m_dwThreadID);

			nError = SetSerial(m_hPort, m_nBaud, m_nDataBits, m_nParity, 0, m_nFlowCtrl);
			if(nError){
				strTemp.Format("SetSerial Error: %d", nError);
				AfxMessageBox(strTemp);
			}

			GetDlgItem(IDC_COMBO_PORT)->EnableWindow(FALSE);
			GetDlgItem(IDC_BTN_PORTSETTING)->EnableWindow(FALSE);
			GetDlgItem(IDC_BTN_CONNECT)->SetWindowText("Disconnect");
			m_bConnect = TRUE;
			g_f.Open("C:\\RD.txt", CFile::modeCreate|CFile::modeWrite);
		}
		else{
			nError = GetError();
			strTemp.Format("Error: %d", nError);
			AfxMessageBox(strTemp);
		}
	}
}

void CComTestDlg::OnChangeEditWrite() 
{
	CString strTemp;
	int nWrite;
	
	if(!m_hPort)
		return;

	UpdateData();
	if(m_strWritten.GetLength() <  m_strWrite.GetLength()){
		strTemp = m_strWrite.Right(m_strWrite.GetLength() - m_strWritten.GetLength());
		nWrite = WriteCom_Entry(m_hPort, strTemp.GetLength(), strTemp.LockBuffer());
		strTemp.UnlockBuffer();
		if(!nWrite){
			strTemp.Format("WriteCom_Entry Error:%d", GetError());
			AfxMessageBox(strTemp);
		}
	}

	m_strWritten = m_strWrite;
}

void CComTestDlg::OnSelchangeComboPort() 
{
	CString strTemp;

	m_ctrlPort.GetWindowText(strTemp);
	strTemp.MakeUpper();
	GetDlgItem(IDC_BTN_PORTSETTING)->EnableWindow(strTemp.Find("COM") >= 0);
}

void CComTestDlg::OnBtnTransfile() 
{
	if(!m_hPort)
		return;

	CFileDialog	dlg(TRUE, NULL, m_strTransFile, OFN_FILEMUSTEXIST | OFN_READONLY, "Transmission Files (*.*)|*.*||");

	if(dlg.DoModal() != IDOK)
		return;

	CFile	f;
	DWORD	dwLen;
	LPBYTE	lpBuf;

	m_strTransFile = dlg.GetPathName();
	f.Open(m_strTransFile, CFile::modeRead);
	dwLen = f.GetLength();
	lpBuf = (LPBYTE)new char[dwLen];
	f.Read(lpBuf, dwLen);
	f.Close();

	int nError = WriteCom_Entry(m_hPort, dwLen, (char *)lpBuf);

	AfxMessageBox("Transmission done!!!");
}

void CComTestDlg::OnOK() 
{
	CloseAllCom_Entry();
	
	CDialog::OnOK();
}

void CComTestDlg::OnButton1() 
{
	PurgeCom(m_hPort);
}

void CComTestDlg::OnBtnPortsetting() 
{
	CString strTemp;
	
	m_ctrlPort.GetWindowText(strTemp);;
	CComSetting	dlg(strTemp, m_nBaud, m_nDataBits, m_nParity, m_nFlowCtrl);

	if(dlg.DoModal() != IDOK)
		return;

	m_nBaud = dlg.m_nBaud;
	m_nDataBits = dlg.m_nDataBits;
	m_nParity = dlg.m_nParity;
	m_nFlowCtrl = dlg.m_nFlowCtrl;
	UpdateMess();
}

void CComTestDlg::UpdateMess()
{
	switch(m_nBaud){
	default:
	case 6: m_strPortMess = "115200,"; break;
	case 1: m_strPortMess = "4800,"; break;
	case 2: m_strPortMess = "9600,"; break;
	case 3: m_strPortMess = "19200,"; break;
	case 4: m_strPortMess = "38400,"; break;
	case 5: m_strPortMess = "51200,"; break;
	}

	switch(m_nParity){
	case 0: m_strPortMess += "N,"; break;
	case 1: m_strPortMess += "ODD,"; break;
	case 2: m_strPortMess += "EVEN,"; break;
	}
	
	switch(m_nDataBits){
	case 0:
	case 8: m_strPortMess += "8,"; break;
	case 7: m_strPortMess += "7,"; break;
	}
	
	m_strPortMess += "1,";

	switch(m_nFlowCtrl){
	default: m_strPortMess += "none"; break;
	case 1: m_strPortMess += "hardware"; break;
	}
	UpdateData(FALSE);
}