// ConvertDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ProtocolTest.h"
#include "ConvertDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConvertDlg dialog


CConvertDlg::CConvertDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConvertDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConvertDlg)
	m_strOriFile = _T("");
	m_strOriFieldLen = _T("");
	m_strConvFile = _T("");
	m_nFieldNum = 1;
	m_strConvFieldLen = _T("");
	//}}AFX_DATA_INIT
}


void CConvertDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConvertDlg)
	DDX_Control(pDX, IDC_COMBO2, m_cboConvSeparator);
	DDX_Control(pDX, IDC_COMBO1, m_cboOriSeparator);
	DDX_Text(pDX, IDC_EDIT1, m_strOriFile);
	DDX_Text(pDX, IDC_EDIT2, m_strOriFieldLen);
	DDX_Text(pDX, IDC_EDIT3, m_strConvFile);
	DDX_Text(pDX, IDC_EDIT4, m_nFieldNum);
	DDV_MinMaxInt(pDX, m_nFieldNum, 1, 20);
	DDX_Text(pDX, IDC_EDIT5, m_strConvFieldLen);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConvertDlg, CDialog)
	//{{AFX_MSG_MAP(CConvertDlg)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnSelchangeCombo2)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConvertDlg message handlers

BOOL CConvertDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_cboOriSeparator.SetCurSel(3);
	m_cboConvSeparator.SetCurSel(3);
	OnSelchangeCombo1();
	OnSelchangeCombo2();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConvertDlg::OnSelchangeCombo1() 
{
	CString strTemp;

	GetDlgItem(IDC_STATIC1)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EDIT2)->ShowWindow(SW_HIDE);
	
	m_cboOriSeparator.GetLBText(m_cboOriSeparator.GetCurSel(), strTemp);

	if(!strTemp.Compare("Length")){
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT2)->ShowWindow(SW_SHOW);
	}
	/*else if(!strTemp.Compare("Tab"))
		m_pCurSel->m_cSeparator = 0x09;
	else if(!strTemp.Compare("Space"))
		m_pCurSel->m_cSeparator = 0x20;
	else
		m_pCurSel->m_cSeparator = strTemp.GetAt(0);*/
	
}

void CConvertDlg::OnSelchangeCombo2() 
{
	CString strTemp;

	GetDlgItem(IDC_STATIC3)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EDIT5)->ShowWindow(SW_HIDE);
	
	m_cboConvSeparator.GetLBText(m_cboConvSeparator.GetCurSel(), strTemp);

	if(!strTemp.Compare("Length")){
		GetDlgItem(IDC_STATIC3)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT5)->ShowWindow(SW_SHOW);
	}
}

void CConvertDlg::OnButton1() 
{
	CFileDialog  dlg(TRUE, "*.*", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "data Files (*.*)|*.*||");

	if(dlg.DoModal() == IDOK)
		m_strOriFile  = dlg.GetPathName();

	UpdateData(FALSE);
}

void CConvertDlg::OnOK() 
{
	BOOL	bInvalid;
	CString strTemp;

	UpdateData();
	bInvalid = FALSE;
	if(m_strOriFile.IsEmpty() || m_strConvFile.IsEmpty())
		bInvalid = TRUE;
		
	if(!m_cboOriSeparator.GetCurSel() && m_strOriFieldLen.IsEmpty())
		bInvalid = TRUE;

	if(!m_cboConvSeparator.GetCurSel() && m_strConvFieldLen.IsEmpty())
		bInvalid = TRUE;

	if(bInvalid){
		AfxMessageBox("Invalid Data!");
		return;
	}
	
	m_cboOriSeparator.GetLBText(m_cboOriSeparator.GetCurSel(), strTemp);
	if(!strTemp.Compare("Length"))
		m_cOriSeparator = 0;
	else if(!strTemp.Compare("Tab"))
		m_cOriSeparator = 0x09;
	else if(!strTemp.Compare("Space"))
		m_cOriSeparator = 0x20;
	else
		m_cOriSeparator = strTemp.GetAt(0);

	m_cboConvSeparator.GetLBText(m_cboConvSeparator.GetCurSel(), strTemp);
	if(!strTemp.Compare("Length"))
		m_cConvSeparator = 0;
	else if(!strTemp.Compare("Tab"))
		m_cConvSeparator = 0x09;
	else if(!strTemp.Compare("Space"))
		m_cConvSeparator = 0x20;
	else
		m_cConvSeparator = strTemp.GetAt(0);

	CDialog::OnOK();
}
