// ProtocolTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ProtocolTest.h"
#include "ProtocolTestDlg.h"
#include "..\\..\\Library\\Protocol.h"
#include "..\\..\\Library\\TransErr.h"
#include "..\\..\\Library\\Type.h"
#include "ConvertDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProtocolTestDlg dialog

CProtocolTestDlg::CProtocolTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProtocolTestDlg::IDD, pParent)
{
	m_hPort = NULL;
	m_bConnect = FALSE;
	m_nFuncSel = -1;

	//{{AFX_DATA_INIT(CProtocolTestDlg)
	m_nBaud = 5;
	m_strVersion = _T("");
	m_strEdit1 = _T("");
	m_strEdit2 = _T("");
	//}}AFX_DATA_INIT

	char	*pVer;

	pVer = (char *) new char[10];
	memset(pVer, 0, 10);
	GetPTProtocolVersion(pVer);
	m_strVersion.Format("%s", pVer);
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CProtocolTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProtocolTestDlg)
	DDX_Control(pDX, IDC_LIST2, m_list2);
	DDX_Control(pDX, IDC_LIST1, m_list1);
	DDX_Control(pDX, IDC_LIST_FUNCTION, m_listFunction);
	DDX_Control(pDX, IDC_COMBO_PORT, m_ctrlPort);
	DDX_CBIndex(pDX, IDC_COMBO_BAUD, m_nBaud);
	DDX_Text(pDX, IDC_EDIT_VERSION, m_strVersion);
	DDX_Text(pDX, IDC_EDIT1, m_strEdit1);
	DDX_Text(pDX, IDC_EDIT2, m_strEdit2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CProtocolTestDlg, CDialog)
	//{{AFX_MSG_MAP(CProtocolTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_CONNECT, OnBtnConnect)
	ON_CBN_SELCHANGE(IDC_COMBO_PORT, OnSelchangeComboPort)
	ON_BN_CLICKED(IDC_BUTTON_EXECUTE, OnButtonExecute)
	ON_LBN_SELCHANGE(IDC_LIST_FUNCTION, OnSelchangeListFunction)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProtocolTestDlg message handlers

BOOL CProtocolTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CString strTemp;
	DWORD	i, dwValue;
	char	*name;
	int		nMax, nError;

	GetWindowText(strTemp);
	strTemp += "-";
	strTemp += m_strVersion;
	SetWindowText(strTemp);

	name = (char *) new char[100];
	dwValue = PT_EnumUSB();
	for(i = 0 ; i < dwValue ; i++){
		nMax = PT_GetUSBNameMaxLen();
		if(nMax > 100){
			delete name;
			name = new char[nMax];
		}

		nError = PT_GetUSBName(i, name, &nMax);
		if(nError){
			strTemp.Format("PT_GetEUSBName() error:%d", nError);
			AfxMessageBox(strTemp);
		}
		else{
			strTemp.Format("%s", name);
			m_ctrlPort.AddString(strTemp);
		}
	}
	
	m_ctrlPort.SetCurSel(0);

	m_listFunction.AddString("PT_DownloadFile");
	m_listFunction.AddString("PT_GetPDTFile");
	m_listFunction.AddString("PT_DirFile");
	m_listFunction.AddString("PT_DeleteFile");
	m_listFunction.AddString("PT_FormatDisk");
	m_listFunction.AddString("PT_GetDiskInfo");
	m_listFunction.AddString("PT_SetTime");
	m_listFunction.AddString("PT_GetPDTInformation");
	m_listFunction.AddString("PT_DownloadApplication");
	m_listFunction.AddString("PT_DownloadMultiFile");
	m_listFunction.AddString("PT_EncryptFile");
	m_listFunction.AddString("PT_DownloadEncryptFile");
	m_listFunction.AddString("PT_ConvertFile");
	m_listFunction.AddString("PT_SetAgentID");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CProtocolTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CProtocolTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CProtocolTestDlg::OnBtnConnect() 
{
	int nPort, nPortType, nError;
	CString strTemp, strPort;
	
	UpdateData();
	GetDlgItem(IDC_COMBO_PORT)->EnableWindow(TRUE);
	GetDlgItem(IDC_COMBO_BAUD)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_EXECUTE)->EnableWindow(FALSE);
	GetDlgItem(IDC_BTN_CONNECT)->SetWindowText("Connect");
	m_listFunction.EnableWindow(FALSE);

	if(m_bConnect){
		nError = PT_ClosePort(m_hPort);
		m_hPort = NULL;
		m_bConnect = FALSE;
		m_listFunction.SetCurSel(-1);
		OnSelchangeListFunction();
	}
	else{
		nPort = m_ctrlPort.GetCurSel();
		if(nPort >= 4){
			nPortType = 2;
			nPort -= 3;
		}
		else{
			m_ctrlPort.GetWindowText(strPort);
			nPortType = 1;
			strTemp = strPort.Right(strPort.GetLength() - 3);
			nPort = atoi(strTemp.LockBuffer());
			strTemp.UnlockBuffer();
		}
		
		m_hPort = PT_OpenPort(nPortType, nPort, NULL, m_nBaud+1);
		if(m_hPort){
			GetDlgItem(IDC_COMBO_PORT)->EnableWindow(FALSE);
			GetDlgItem(IDC_COMBO_BAUD)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_EXECUTE)->EnableWindow(TRUE);
			GetDlgItem(IDC_BTN_CONNECT)->SetWindowText("Disconnect");
			m_listFunction.EnableWindow(TRUE);
			m_bConnect = TRUE;
		}
		else{
			nError = PT_GetErrorCode();
			strTemp.Format("PT_GetErrorCode error:%d", nError);
			AfxMessageBox(strTemp);
		}
	}
}

void CProtocolTestDlg::OnSelchangeComboPort() 
{
	CString strTemp;

	m_ctrlPort.GetWindowText(strTemp);
	strTemp.MakeUpper();
	GetDlgItem(IDC_COMBO_BAUD)->EnableWindow(strTemp.Find("COM") >= 0);
}

void CProtocolTestDlg::OnCancel() 
{
	PT_CloseAllPort();
	
	CDialog::OnCancel();
}

void CProtocolTestDlg::OnButtonExecute() 
{
	int		nError, nItem, nMaxBuf, i;
	CString	strTemp, strTemp1, strTemp2, strTemp3;
	char	*pData, pTemp1[20], pTemp2[20], pTemp3[20], pTemp4[20], *p;
	DIRINFO	*pDir;
	BOOL	bShowMessage;
	long	llong1, llong2, llong3;
	CConvertDlg	dlg;

	UpdateData();
	nError = nItem = nMaxBuf = 0;
	pData = NULL;
	bShowMessage = FALSE;

	switch(m_nFuncSel){
	case -1:
		AfxMessageBox("Select a function to execute");
		return;
	case 0:
		if(m_strEdit1.IsEmpty()){
			AfxMessageBox("Select a file for download");
			return;
		}

		if(m_list2.GetCurSel() == -1){
			AfxMessageBox("Select a destination");
			return;
		}

		m_list2.GetText(m_list2.GetCurSel(), strTemp);
		strTemp += m_strEdit1.Right(m_strEdit1.GetLength() - m_strEdit1.ReverseFind('\\'));
		nError = PT_DownloadFile(m_hPort, m_strEdit1.LockBuffer(), strTemp.LockBuffer(), 1, 1);
		break;
	case 1:
		if(m_strEdit1.IsEmpty()){
			AfxMessageBox("Input terminal file to upload");
			return;
		}

		if(m_strEdit2.IsEmpty()){
			AfxMessageBox("Input the PC destination to upload.");
			return;
		}

		strTemp = m_strEdit2 + m_strEdit1.Right(m_strEdit1.GetLength() - m_strEdit1.ReverseFind('\\'));
		nError = PT_GetPDTFile(m_hPort, m_strEdit1.LockBuffer(), m_strEdit2.LockBuffer(), 1);
		break;
	case 2:
		if(m_list1.GetCurSel() == -1){
			AfxMessageBox("Select a dir destination");
			return;
		}

		m_list1.GetText(m_list1.GetCurSel(), strTemp);

		if(strTemp.IsEmpty()){
			AfxMessageBox("Select a location to dir.");
			return;
		}

		nMaxBuf = 100;
		pData = new char[nMaxBuf+1];
		memset(pData, 0, nMaxBuf+1);
		nError = PT_DirFile(m_hPort, strTemp.LockBuffer(), &nItem, pData, &nMaxBuf);

		if(nError == ERR_INSUFFICIENT_SPACE){
			delete pData;
			pData = new char[nMaxBuf+1];
			memset(pData, 0, nMaxBuf+1);
			nError = PT_DirFile(m_hPort, strTemp.LockBuffer(), &nItem, pData, &nMaxBuf);
		}

		m_strEdit2.Empty();
		if(!nError){
			p = pData;

			for( i = 0 ; i < nItem ; i++){
				pDir = (DIRINFO *)p;
				memset(pTemp1, 0, 20);
				
				if(pDir->usType == 2){
					strncpy(pTemp1, (char *)pDir->assFName, 8);
					strcat(pTemp1, ".");
					strncat(pTemp1, (char *)pDir->assExtend, 3);
					strTemp.Format("%s", pTemp1);
				}
				else{
					strncpy(pTemp1, (char *)pDir->assFName, 8);
					strTemp.Format("%s", pTemp1);
				}
					
				m_strEdit2 += (strTemp + "\r\n");
				p += 32;
			}
		}

		break;
	case 3:
		if(m_strEdit1.IsEmpty()){
			AfxMessageBox("Input a terminal file to delete");
			return;
		}

		nError = PT_DeleteFile(m_hPort, m_strEdit1.LockBuffer());
		break;
	case 4:
	case 5:
		i = m_list1.GetCurSel();

		if(i == -1){
			AfxMessageBox("Select a terminal disk");
			return;
		}

		m_list1.GetText(i, strTemp);

		if(m_nFuncSel == 4)
			nError = PT_FormatDisk(m_hPort, strTemp.LockBuffer());
		else{
			nError = PT_GetDiskInfo(m_hPort, strTemp.LockBuffer(), llong1, llong2, llong3);

			if(!nError){
				bShowMessage = TRUE;
				if(i)
					strTemp.Format("Disk D:\r\nTotal Space: %d bytes\r\nUsed Space: %d bytes\r\nFree Space: %d bytes", llong1, llong2, llong3);
				else
					strTemp.Format("Disk C:\r\nTotal Space: %d bytes\r\nUsed Space: %d bytes\r\nFree Space: %d bytes", llong1, llong2, llong3);
				AfxMessageBox(strTemp);
			}
		}
		break;
	case 6:
		if(m_strEdit1.IsEmpty()){
			AfxMessageBox("Input the time to setup");
			return;
		}

		if(m_strEdit1.GetLength() < 14){
			AfxMessageBox("Input the time to setup");
			return;
		}

		memset(pTemp1, 0, 20);
		strncpy(pTemp1, m_strEdit1.LockBuffer(), 14);
		nError = PT_SetTime(m_hPort, pTemp1);
		break;
	case 7:
		memset(pTemp1, 0, 20);
		memset(pTemp2, 0, 20);
		memset(pTemp3, 0, 20);
		memset(pTemp4, 0, 20);
		nError = PT_GetPDTInformation(m_hPort, pTemp1, pTemp2, pTemp3, pTemp4);

		if(!nError){
			bShowMessage = TRUE;
			strTemp.Format("PDT Name:%s\r\nF/W Version:%s\r\nS/N:%s\r\nEquip ID:%s", pTemp1, pTemp2, pTemp3, pTemp4);
			AfxMessageBox(strTemp);
		}
		break;
	case 8:
		if(m_strEdit1.IsEmpty()){
			AfxMessageBox("Select a application file for download");
			return;
		}

		if(AfxMessageBox("Make sure your terminal is in AP Install Mode", MB_YESNO) == IDNO)
			return;

		nError = PT_DownloadApplication(m_hPort, m_strEdit1.LockBuffer(), 1);
		break;
	case 9:
		if(m_strEdit1.IsEmpty()){
			AfxMessageBox("Input file for download");
			return;
		}

		if(m_list2.GetCurSel() == -1){
			AfxMessageBox("Select a destination");
			return;
		}

		for( i = 0, nItem = 0 ; i < m_strEdit1.GetLength() ; ){
			i = m_strEdit1.Find("\r\n", i) + 2;
			nItem++;
		}

		m_list2.GetText(m_list2.GetCurSel(), strTemp2);
		strTemp1 = m_strEdit1;

		i = 1;
		do{
			strTemp = strTemp1.Left(strTemp1.Find("\r\n"));
			strTemp3 = strTemp2 + strTemp.Right(strTemp.GetLength() - strTemp.ReverseFind('\\'));
			nError = PT_DownloadMultiFile(m_hPort, strTemp.LockBuffer(), strTemp3.LockBuffer(), 1, nItem, i++, 1);
			strTemp1 = strTemp1.Right(strTemp1.GetLength() - strTemp1.Find("\r\n") - 2);
		}while(!nError && strTemp1.Find("\r\n") != -1);
		break;
	case 10:
		if(m_strEdit1.IsEmpty()){
			AfxMessageBox("Input file for encrypt");
			return;
		}

		nError = PT_EncryptFile(m_strEdit1.LockBuffer(), m_strEdit1.LockBuffer());
		break;
	case 11:
		if(m_strEdit1.IsEmpty()){
			AfxMessageBox("Select a encrypted file for download");
			return;
		}

		if(m_list2.GetCurSel() == -1){
			AfxMessageBox("Select a destination");
			return;
		}

		nError = PT_DownloadEncryptFile(m_hPort, m_strEdit1.LockBuffer(), m_list2.GetCurSel()+1, 1, 1);
		break;
	case 12:
		if(dlg.DoModal() != IDOK){
			bShowMessage = TRUE;
			break;
		}
		
		nError = PT_ConvertFile(dlg.m_strOriFile.LockBuffer(), dlg.m_strConvFile.LockBuffer(), dlg.m_cOriSeparator,
			dlg.m_strOriFieldLen.LockBuffer(), dlg.m_nFieldNum, dlg.m_cConvSeparator, dlg.m_strConvFieldLen.LockBuffer());
		break;
	case 13:	// PT_SetAgentID
		if(m_strEdit1.IsEmpty()){
			AfxMessageBox("Agent ID cannot be empty.");
			return;
		}
		
		if(m_strEdit2.IsEmpty()){
			AfxMessageBox("Password cannot be empty.");
			return;
		}

		nError = PT_SetAgentID(m_hPort, m_strEdit1.LockBuffer(), m_strEdit2.LockBuffer());
		break;
	}	

	if(nError)
		strTemp.Format("Some Error.\nError code:%d", nError);
	else
		strTemp = "Function had done";

	if(!bShowMessage)
		AfxMessageBox(strTemp);

	if(pData)
		delete pData;

	UpdateData(FALSE);
}

void CProtocolTestDlg::OnSelchangeListFunction() 
{
	UpdateData();
	m_nFuncSel = m_listFunction.GetCurSel();
	GetDlgItem(IDC_STATIC1)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATIC2)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EDIT1)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EDIT2)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EDIT2)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON1)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATIC1)->SetWindowText("");
	GetDlgItem(IDC_STATIC2)->SetWindowText("");
	GetDlgItem(IDC_BUTTON1)->SetWindowText("");
	m_list1.ShowWindow(SW_HIDE);
	m_list2.ShowWindow(SW_HIDE);
	m_list1.ResetContent();
	m_list2.ResetContent();

	if(m_nOldFuncSel != m_nFuncSel){
		m_strEdit1.Empty();
		m_strEdit2.Empty();
	}

	switch(m_nFuncSel){
	case 0:
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC2)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BUTTON1)->ShowWindow(SW_SHOW);
		m_list2.ShowWindow(SW_SHOW);

		GetDlgItem(IDC_STATIC1)->SetWindowText("PC File");
		GetDlgItem(IDC_STATIC2)->SetWindowText("PDT Destination");
		GetDlgItem(IDC_BUTTON1)->SetWindowText("Search");

		m_list2.AddString("C:\\Data");
		m_list2.AddString("D:\\Fonts");
		m_list2.AddString("D:\\Lookup");
		m_list2.AddString("D:\\Program");
		break;
	case 1:
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC2)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT2)->ShowWindow(SW_SHOW);

		GetDlgItem(IDC_STATIC1)->SetWindowText("PDT File");
		GetDlgItem(IDC_STATIC2)->SetWindowText("PC Destination");
		break;
	case 2:
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC2)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT2)->ShowWindow(SW_SHOW);
		m_list1.ShowWindow(SW_SHOW);

		GetDlgItem(IDC_STATIC1)->SetWindowText("Dir Terimnal Folder");
		GetDlgItem(IDC_STATIC2)->SetWindowText("Dir Result");

		m_list1.AddString("C:\\");
		m_list1.AddString("D:\\");
		m_list1.AddString("C:\\Data");
		m_list1.AddString("D:\\Fonts");
		m_list1.AddString("D:\\Lookup");
		m_list1.AddString("D:\\Program");
		break;
	case 3:
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT1)->ShowWindow(SW_SHOW);

		GetDlgItem(IDC_STATIC1)->SetWindowText("Delete Terimnal File");
		break;
	case 4:
	case 5:
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		m_list1.ShowWindow(SW_SHOW);

		GetDlgItem(IDC_STATIC1)->SetWindowText("Select a terminal disk");

		m_list1.AddString("C:\\");
		m_list1.AddString("D:\\");
		break;
	case 6:
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC2)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT2)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT2)->EnableWindow(FALSE);

		GetDlgItem(IDC_STATIC1)->SetWindowText("Input setting time");
		GetDlgItem(IDC_STATIC2)->SetWindowText("Format:");
		m_strEdit2 = "(2009/10/13 14:23:15)\r\n20091013142315";
		break;
	case 7:
		break;
	case 8:
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BUTTON1)->ShowWindow(SW_SHOW);
		
		GetDlgItem(IDC_STATIC1)->SetWindowText("Application File");
		GetDlgItem(IDC_BUTTON1)->SetWindowText("Search");
		break;
	case 9:
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC2)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BUTTON1)->ShowWindow(SW_SHOW);
		m_list2.ShowWindow(SW_SHOW);

		GetDlgItem(IDC_STATIC1)->SetWindowText("PC File");
		GetDlgItem(IDC_STATIC2)->SetWindowText("PDT Destination");
		GetDlgItem(IDC_BUTTON1)->SetWindowText("Search");

		m_list2.AddString("C:\\Data");
		m_list2.AddString("D:\\Fonts");
		m_list2.AddString("D:\\Lookup");
		m_list2.AddString("D:\\Program");
		break;
	case 10:
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BUTTON1)->ShowWindow(SW_SHOW);

		GetDlgItem(IDC_STATIC1)->SetWindowText("File");
		GetDlgItem(IDC_BUTTON1)->SetWindowText("Search");
		break;
	case 11:
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC2)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_BUTTON1)->ShowWindow(SW_SHOW);
		m_list2.ShowWindow(SW_SHOW);

		GetDlgItem(IDC_STATIC1)->SetWindowText("PC Encrypted File");
		GetDlgItem(IDC_STATIC2)->SetWindowText("PDT Destination");
		GetDlgItem(IDC_BUTTON1)->SetWindowText("Search");

		m_list2.AddString("C:\\Data");
		m_list2.AddString("D:\\Fonts");
		m_list2.AddString("D:\\Lookup");
		m_list2.AddString("D:\\Program");
		break;
	case 13:	// PT_SetAgentID
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC2)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_EDIT2)->ShowWindow(SW_SHOW);

		GetDlgItem(IDC_STATIC1)->SetWindowText("Agent ID(4 ~ 8 digits):");
		GetDlgItem(IDC_STATIC2)->SetWindowText("Password(4 ~ 8 digits):");
	}

	m_nOldFuncSel = m_nFuncSel;
	UpdateData(FALSE);
}

void CProtocolTestDlg::OnButton1() 
{
	CString strTemp;
	char	*pFileBuf, *p;

	if(m_nFuncSel == 0 || m_nFuncSel == 11){
		CFileDialog  dlg(TRUE, "*.*", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "All Files (*.*)|*.*||");

		if(dlg.DoModal() == IDOK)
			m_strEdit1 = dlg.GetPathName();
	}
	else if(m_nFuncSel == 8){
		CFileDialog  dlg(TRUE, "*.bin", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Application Files (*.bin)|*.bin||");

		if(dlg.DoModal() == IDOK)
			m_strEdit1 = dlg.GetPathName();
	}
	else if(m_nFuncSel == 9){
		pFileBuf = (char *) new char[1024];
		memset(pFileBuf, 0, 1024);
		CFileDialog  dlg(TRUE, "*.*", NULL, OFN_ALLOWMULTISELECT| OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "All Files (*.*)|*.*||");
		dlg.m_ofn.lpstrFile = pFileBuf;

		if(dlg.DoModal() == IDOK){
			m_strEdit1.Empty();
			p = pFileBuf;

			do{
				p += strlen(p) + 1;
				strTemp.Format("%s\\%s\r\n", pFileBuf, p);
				m_strEdit1 += strTemp;
			}while(*(p + strlen(p) + 1));
		}
	}
	else if(m_nFuncSel == 10){
		CFileDialog  dlg(TRUE, "default.bas", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Basic Files (*.bas)|*.bas||");

		if(dlg.DoModal() == IDOK)
			m_strEdit1 = dlg.GetPathName();
	}

	UpdateData(FALSE);
}
