// Application.c

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "SDK.h"


void DEMO_Prog(void);
void ProductInfo_Prog(void);


void FileTran(void)
{
	RemoteLink();
}

void InterFace_COM(void)
{
	SetRemoteInterface(0);
}

void InterFace_USB(void)
{
	SetRemoteInterface(1);
}

MENU_ENTRY_COLOR Set_InterFace_COM		= {0, 1, "1.COM Port", &InterFace_COM, 0};
MENU_ENTRY_COLOR Set_InterFace_USB		= {0, 2, "2.USB", &InterFace_USB, 0};

MENU_COLOR InterFace_Menu = {2, 1, 1, "  Interface", COLOR_BROWN, COLOR_BLACK, COLOR_LIGHTBLUE
						, {&Set_InterFace_COM, &Set_InterFace_USB}};


void Set_InterFace(void)
{
	if (GetRemoteInterface() == 0)//RS-232
	{
		InterFace_Menu.selected_entry = 1;
	}
	else
	{
		InterFace_Menu.selected_entry = 2;
	}
	prc_menu_color(&InterFace_Menu);
}





void BaudRate_115200(void)
{
	SetRemoteBaud(0);
}

void BaudRate_57600(void)
{
	SetRemoteBaud(1);
}

void BaudRate_38400(void)
{
	SetRemoteBaud(2);
}

void BaudRate_19200(void)
{
	SetRemoteBaud(3);
}

void BaudRate_9600(void)
{
	SetRemoteBaud(4);
}

void BaudRate_4800(void)
{
	SetRemoteBaud(5);
}

MENU_ENTRY_COLOR BaudRate115200		= {0, 1, "1.115200 bps", &BaudRate_115200, 0};
MENU_ENTRY_COLOR BaudRate57600		= {0, 2, "2.57600 bps", &BaudRate_57600, 0};
MENU_ENTRY_COLOR BaudRate38400		= {0, 3, "3.38400 bps", &BaudRate_38400, 0};
MENU_ENTRY_COLOR BaudRate19200		= {0, 4, "4.19200 bps", &BaudRate_19200, 0};
MENU_ENTRY_COLOR BaudRate9600		= {0, 5, "5.9600 bps", &BaudRate_9600, 0};
MENU_ENTRY_COLOR BaudRate4800		= {0, 6, "6.4800 bps", &BaudRate_4800, 0};

MENU_COLOR BaudRate_Set = {6, 1, 1, "  Baud Rate", COLOR_BROWN, COLOR_BLACK, COLOR_LIGHTBLUE
						, {&BaudRate115200, &BaudRate57600, &BaudRate38400,
							&BaudRate19200, &BaudRate9600, &BaudRate4800}};


void SET_BaudRate(void)
{
	if (GetRemoteInterface() == 1)
	{
		gotoxy(0,0);
		_printf_color(COLOR_BROWN, "  Baud Rate");
		gotoxy(0,1);
		_printf_color(COLOR_RED, "Now is USB mode, you cannot set Baud \nrate.");		
		while(_getchar() == 0);
	}
	else
	{
		BaudRate_Set.selected_entry = GetRemoteBaud() + 1;
		prc_menu_color(&BaudRate_Set);
	}
}

MENU_ENTRY_COLOR Comm_FT			= {0, 1, "1.File Transfer", &FileTran, 0};
MENU_ENTRY_COLOR Comm_InterFace		= {0, 2, "2.Interface", &Set_InterFace,0};
MENU_ENTRY_COLOR Comm_BaudRate		= {0, 3, "3.Baud Rate", &SET_BaudRate, 0};

MENU_COLOR Comm_Menu = {3, 1, 0, "  Communication", COLOR_BROWN, COLOR_BLACK, COLOR_LIGHTBLUE
						, {&Comm_FT, &Comm_InterFace, &Comm_BaudRate}};




MENU_ENTRY_COLOR DEMO			= {0, 1, "1.Demo Program", &DEMO_Prog, 0};
MENU_ENTRY_COLOR ProductInfo	= {0, 2, "2.Product Info.", &ProductInfo_Prog, 0};
MENU_ENTRY_COLOR Remote_Link	= {0, 3, "3.Communication", 0, &Comm_Menu};

void Application_Main(void)
{
	MENU_COLOR DEMO_Menu = {3, 1, 0, "  == Argox DEMO ==", COLOR_BROWN, COLOR_BLACK, COLOR_LIGHTBLUE
						, {&DEMO, &ProductInfo, &Remote_Link}};
	/////For Simulator////
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 1\\Lookup\\Lookup.txt", "D:\\Lookup\\Lookup.txt");
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 1\\Lookup\\000.bmp", "D:\\Lookup\\000.bmp");
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 1\\Lookup\\001.bmp", "D:\\Lookup\\001.bmp");
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 1\\Lookup\\002.bmp", "D:\\Lookup\\002.bmp");
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 1\\Lookup\\003.bmp", "D:\\Lookup\\003.bmp");
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 1\\Lookup\\004.bmp", "D:\\Lookup\\004.bmp");
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 1\\Lookup\\005.bmp", "D:\\Lookup\\005.bmp");
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 1\\Lookup\\006.bmp", "D:\\Lookup\\006.bmp");
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 1\\Lookup\\007.bmp", "D:\\Lookup\\007.bmp");
	//////////////////////
	dis_alpha();
	clr_scr();

	while(1)
	{
		prc_menu_color(&DEMO_Menu);	
	}
}

#define LOOKUP_SEARCH_TYPE				1
#define LOOKUP_SEARCH_FIELDDLT			","
#define LOOKUP_SEARCH_LENGTH			0
#define LOOKUP_SEARCH_TOTALFIELDNO		4
#define LOOKUP_SEARCH_TOTALRECORDNO		-1

#define DATA_SEARCH_TYPE				1
#define DATA_SEARCH_FIELDDLT			","
#define DATA_SEARCH_LENGTH				0
#define DATA_SEARCH_TOTALFIELDNO		2
#define DATA_SEARCH_TOTALRECORDNO		-1


void DEMO_Prog(void)
{
	_TFILE *fp_Lookup = NULL, *fp_Data = NULL, *fp_BMP = NULL;
	_DBMS stLookupSearch, stDataSearch;

	int slGetSCAN, slGetRec;
	int slBMPSize;
	int slQty;
	char assSN[8], assModelName[20], assPATH[20];
	char assQty[12], assQty_Input[12], assQty_Add[12];
	char* pssBMPfile = NULL;
	char assAppendRec[40];
	
	fp_Lookup = _fopen("D:\\Lookup\\Lookup.txt", "r");
	if (fp_Lookup == NULL)
	{
		gotoxy(0,1);
		_printf_color(COLOR_BLACK, "No Lookup File!");

		gotoxy(0,8);
		_printf_color(COLOR_BLACK, "Any key return....");
		while(_getchar() == 0);
		Set_Cursor(0);
		return;
	}

	fp_Data = _fopen("C:\\Data\\Collect.txt", "r+");
	if (fp_Data == NULL)
	{
		fp_Data = _fopen("C:\\Data\\Collect.txt", "w+");
	}
	if (fp_Data == NULL)//C Disk unformat
	{
		DiskC_format();
		fp_Data = _fopen("C:\\Data\\Collect.txt", "w+");
	}

	Ini_Search(fp_Lookup, &stLookupSearch, LOOKUP_SEARCH_FIELDDLT, LOOKUP_SEARCH_TYPE, LOOKUP_SEARCH_LENGTH, 
				LOOKUP_SEARCH_TOTALFIELDNO, LOOKUP_SEARCH_TOTALRECORDNO);

	Ini_Search(fp_Data, &stDataSearch, DATA_SEARCH_FIELDDLT, DATA_SEARCH_TYPE, DATA_SEARCH_LENGTH, 
				DATA_SEARCH_TOTALFIELDNO, DATA_SEARCH_TOTALRECORDNO);

	while(1)
	{
		memset(assSN, 0x0, 8);
		memset(assModelName, 0x0, 20);
		memset(assPATH, 0x0, 20);

		clr_scr();
		_printf_color(COLOR_BROWN, "    Demo Program");

		gotoxy(0,11);
		_printf_color(COLOR_BLACK, "ESC:Return");

		gotoxy(0,6);
		_printf_color(COLOR_BLACK, "Import:");

		gotoxy(0,7);
		_scanf_ctrl_ScannerStatus(TRUE);
		_scanf_ctrl_ScanWithENT(TRUE);
		_scanf_ctrl_Vibrate(TRUE);
		_scanf_ctrl_AlphaKey(FALSE);
		_scanf_ctrl_AlphaKey_Mode(ALPHA_123);
		_scanf_ctrl_password(0);
		_scanf_ctrl_KeypadLock(FALSE);

		Set_Cursor(3);
		slGetSCAN = _scanf_color(COLOR_BLACK, "%5s", &assSN);
		Set_Cursor(0);

		if (slGetSCAN == 0)//No Input
			continue;
		else if (slGetSCAN == 0xFF)//Press ESC Key
		{
			_fclose(fp_Lookup);
			_fclose(fp_Data);
			return;
		}
		else
		{
			if ((slGetRec = SearchField(&stLookupSearch, assSN, 0, 0, FORWARD)) != -1)
			{
				ReadField(&stLookupSearch, slGetRec, 1, assModelName);
				ReadField(&stLookupSearch, slGetRec, 3, assPATH);

				gotoxy(0,8);
				_printf_color(COLOR_BLACK, assModelName);

				fp_BMP = _fopen(assPATH, "r+");
				slBMPSize = (S32)_filelength(fp_BMP);
				pssBMPfile = (S8*)Tmalloc(slBMPSize);
				_fread(pssBMPfile, 1, slBMPSize, fp_BMP);

				if (pssBMPfile == NULL)
				{
					fill_rect_color(COLOR_WHITE, 60, 24, 120, 120);
					gotoxy(0,3);
					_printf_color(COLOR_RED, "       No BMP.");

				}
				else
				{
					show_image_bmp(60, 24, 120, 120, pssBMPfile);
				}

				_fclose(fp_BMP);
				fp_BMP = NULL;
				Tfree(pssBMPfile);
				pssBMPfile = NULL;


				memset(assQty, 0x0, 12);

				if ((slGetRec = SearchField_GF(&stDataSearch, assSN, 0, 0, 1, assQty, FORWARD)) != -1)
				{
					gotoxy(0,9);
					_printf_color(COLOR_BLACK, "Quantity(%5s)", assQty);
				}
				else
				{
					gotoxy(0,9);
					_printf_color(COLOR_BLACK, "Quantity(    0)");
				}

				while(1)
				{
					memset(assQty_Input, 0x0, 12);
					gotoxy(0,10);

					clr_eol();
					Set_Cursor(3);
					slGetSCAN = _scanf_color(COLOR_BLACK, "%5s", &assQty_Input);
					Set_Cursor(0);

					if (slGetSCAN == 0)//No Input
						continue;
					else if (slGetSCAN == 0xFF)//Press ESC Key
					{						
						break;
					}
					else
					{
						gotoxy(0,10);
						clr_eol();
						memset(assQty_Add, 0x0, 12);
						slQty = atoi(assQty_Input) + atoi(assQty);

						if (slQty > 99999)
							slQty = 99999;

						if (slQty < 0)
							slQty = 0;

						__itoa(slQty, assQty_Add, 10);

						gotoxy(0,9);
						clr_eol();
						_printf_color(COLOR_BLACK, "Total:%s", assQty_Add);

						memset(assAppendRec, 0, 40);
						strcat(assAppendRec, assSN);
						strcat(assAppendRec, ",");
						strcat(assAppendRec, assQty_Add);

						if (slGetRec == -1)
						{
							AppendRecord(&stDataSearch, assAppendRec);
						}
						else
						{
							WriteRecord(&stDataSearch, slGetRec, assAppendRec);
						}

						SysDelay(2000);
						break;
					}
				}				
				continue;
			}
			else
			{
				_printf_color(COLOR_RED, "\nS/N Error!!");
				SysDelay(1000);
				continue;
			}
		}

	}
}




void ProductInfo_Prog(void)
{
	_TFILE *fp = NULL, *fp_BMP = NULL;
	_DBMS stFileSearch;

	int i = 0;
	char assSN[20], assModelName[20], assOSType[20], assPATH[20];

	char* pssBMPfile = NULL;
	int slBMPSize, slGetKey;

	clr_scr();

	fp = _fopen("D:\\Lookup\\Lookup.txt", "r");
	if (fp == NULL)
	{
		gotoxy(0,1);
		_printf_color(COLOR_BLACK, "No Lookup File!");

		gotoxy(0,8);
		_printf_color(COLOR_BLACK, "Any key return....");
		while(_getchar() == 0);
		Set_Cursor(0);
		return;
	}

	Ini_Search(fp, &stFileSearch, LOOKUP_SEARCH_FIELDDLT, LOOKUP_SEARCH_TYPE, LOOKUP_SEARCH_LENGTH, 
				LOOKUP_SEARCH_TOTALFIELDNO, LOOKUP_SEARCH_TOTALRECORDNO);


	while(1)
	{
		memset(assSN, 0x0, 20);
		memset(assModelName, 0x0, 20);
		memset(assOSType, 0x0, 20);
		memset(assPATH, 0x0, 20);
		clr_scr();
		_printf_color(COLOR_BROWN, "    Product Info.");
		ReadField(&stFileSearch, i, 0, assSN);
		ReadField(&stFileSearch, i, 1, assModelName);
		ReadField(&stFileSearch, i, 2, assOSType);
		ReadField(&stFileSearch, i, 3, assPATH);

		fp_BMP = _fopen(assPATH, "r");
		slBMPSize = (S32)_filelength(fp_BMP);
		pssBMPfile = (S8*)Tmalloc(slBMPSize);
		_fread(pssBMPfile, 1, slBMPSize, fp_BMP);

		if (pssBMPfile == NULL)
		{
			fill_rect_color(COLOR_WHITE, 60, 24, 120, 120);
			gotoxy(0,3);
			_printf_color(COLOR_RED, "       No BMP.");

		}
		else
		{
			show_image_bmp(60, 24, 120, 120, pssBMPfile);
		}

		_fclose(fp_BMP);
		fp_BMP = NULL;
		Tfree(pssBMPfile);
		pssBMPfile = NULL;


		gotoxy(0,6);
		_printf_color(COLOR_ORANGE, "S/N:%s", assSN);
		gotoxy(0,7);
		_printf_color(COLOR_ORANGE, "Model:%s", assModelName);
		gotoxy(0,8);
		_printf_color(COLOR_ORANGE, "OS:%s", assOSType);
		gotoxy(0,11);
		_printf_color(COLOR_BLACK, "ESC:Exit ENT:Next");
		while(1)
		{
			slGetKey = _getchar();
			if (slGetKey == KEY_ESC)
			{
				Close_Search(&stFileSearch);
				return;
			}

			if (slGetKey == KEY_CR)
			{
				i++;
				if (i == stFileSearch.total_record_no)
					i = 0;
				break;
			}
		}

	}
	
}

