
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the PA2XSDK_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// PA2XSDK_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.

#ifdef PA2XSDK_EXPORTS
#define PA2XSDK_API __declspec(dllexport)
#else
#define PA2XSDK_API __declspec(dllimport)
#endif

#define _WINDOWS_TYPE
#include "..\Source\Define.h"


typedef struct __BT_INFO
{
	char assLocalAddress[16];		
	char assLocalName[20];			

	BOOL bLocalSecurity;			
	BOOL bLocalEncryption;		

	int stInquiryTimeout;	
	int stInquirytMaxResponse;	

	char assLinkAddress[16];
	char assPinCode[20];	
	
}_BT_INFO;


typedef struct __BT_DEVINFO_STORE
{
	char assDevAddress[16];
	char assDevName[20];

}_BT_DEVINFO_STORE;


typedef struct __BT_DEVINFO
{
	_BT_DEVINFO_STORE stDevInfo[10];
	int slDevNum;
}_BT_DEVINFO;


typedef struct __DBMS
{
	_TFILE* filehd_C;
	_TFILE* indexhd;				//Index file point
	unsigned char KeyField[12];		//Index key field
	int KeyField_Num;				//Number of key fields
	char *filehd_D;					// D device file point.
	unsigned int filesize_D;		// D device file size.
	unsigned char ausFielddlt[50];	// Character that is used for field delimiter
	int record_type;				// 0 = static length  ,1 = variable length.
	int record_length;				// If record_type=0, it need a value.If record_type=1,it's value
									// can be any value.This value is not include CR_LF byte.
	int total_field_no;				// Total number of fields in a record.
	int total_record_no;			// Total number of records in a file.
									// If total_record_no=-1,it will count total record auto.
	int pos_pre_record;				// Position of precently filepoint.

}_DBMS;

struct SMENU_COLOR 
{
    int total_entry;  
    int selected_entry;
    int ReturnFlag;
    char* title;
	int title_color;
	int menu_color;
	int reverse_menu_color;
    struct SMENU_ENTRY_COLOR* entry_list[14];
};

struct SMENU_ENTRY_COLOR
{
    int text_x;
    int text_y;
    char* text;
    void (*func)(void);
    struct SMENU_COLOR *sub_menu;
};

typedef struct SMENU_COLOR MENU_COLOR;
typedef struct SMENU_ENTRY_COLOR MENU_ENTRY_COLOR;


/***********************           Reader           ****************************/
PA2XSDK_API void SDK_InitScanner1(void);
PA2XSDK_API int SDK_Decode(void);
PA2XSDK_API void SDK_SleepScanner1(BOOL bStatus);
PA2XSDK_API void SDK_HaltScanner1(void);
PA2XSDK_API int SDK_TriggerStatus(void);

PA2XSDK_API BOOL SDK_Scanner_Reset(void);
PA2XSDK_API void SDK_Scanner_Config_Start(void);
PA2XSDK_API void SDK_Scanner_Config_End(void);

PA2XSDK_API BOOL SDK_SCAN_SendCommand(int Command1, int Command2, char *pValue);
PA2XSDK_API BOOL SDK_SCAN_SendCommand_Laser(int Command1,int Command2,char *pValue);
PA2XSDK_API BOOL SDK_SCAN_QueryStatus(int Command1, int Command2, char *pReturn);
PA2XSDK_API BOOL SDK_SCAN_QueryStatus_Laser(int Command1, int Command2, char *pReturn);
PA2XSDK_API BOOL SDK_ScannerSetFromFile(char *pssFilePath);
PA2XSDK_API BOOL SDK_Scanner_All_Symbologies(BOOL bState);
PA2XSDK_API BOOL SDK_Scanner_Version(char* Returnbuf);
PA2XSDK_API void SDK_Sim_ScanKey_Press(BOOL bStatus);

/***************************      Buzzer      *********************************/
PA2XSDK_API int SDK_beeper_status(void);
PA2XSDK_API void SDK_off_beeper(void);
PA2XSDK_API void SDK_on_beeper(int *sequence);
PA2XSDK_API void SDK_SetBuzzerVol(int slVol);

/**************************      Calendar      ********************************/
PA2XSDK_API int SDK_DayOfWeek(void);
PA2XSDK_API int SDK_get_time(char* time_buf);
PA2XSDK_API int SDK_set_time(char* time_buf);

/***********************          BlueTooth         ****************************/
PA2XSDK_API int SDK_BT_Start(void);
PA2XSDK_API int SDK_BT_Stop(void);
PA2XSDK_API int SDK_BT_Open(void);
PA2XSDK_API int SDK_BT_Close(void);
PA2XSDK_API int SDK_BT_Read(char* pssBuf, int slReadSize, int* pslGetSize);
PA2XSDK_API int SDK_BT_Write(char* pssBuf, int slWriteSize, int* pslPutSize);
PA2XSDK_API int SDK_BT_GetLocalInfo(_BT_INFO* stInfo);
PA2XSDK_API int SDK_BT_SetLocalSet(_BT_INFO* stSet);
PA2XSDK_API int SDK_BT_Inquiry(_BT_DEVINFO* stBT_DevInfo, BOOL bGetDevName);
PA2XSDK_API void SDK_BT_DisConnectAlert(BOOL bBeep, int slTimeGap);

/**********************     File Manipulation:       **************************/
PA2XSDK_API int SDK__access(const char *Filename);
PA2XSDK_API int SDK_append(int fd, char* buffer, int count);
PA2XSDK_API int SDK_appendln(int fd, char* buffer);
PA2XSDK_API int SDK_chsize(int fd, long size);
PA2XSDK_API int SDK_close(int fd);
PA2XSDK_API int SDK_delete_top(int fd, int count);
PA2XSDK_API int SDK_delete_topln(int fd);
PA2XSDK_API int SDK_eof(int fd);
PA2XSDK_API long SDK_filelength(int fd);
PA2XSDK_API int SDK_filelist(char* file_list);
PA2XSDK_API long SDK_lseek(int fd, long offset, int origin);
PA2XSDK_API int SDK_open(const char* file_name);
PA2XSDK_API int SDK_read(int fd, char* buffer, int count);
PA2XSDK_API int SDK_read_error_code(void);
PA2XSDK_API int SDK_readln(int fd, char* buffer, unsigned int max_count);
PA2XSDK_API int SDK__remove(const char* file_name);
PA2XSDK_API int SDK__rename(char* old_name,char* new_name);
PA2XSDK_API long SDK_tell(int fd);
PA2XSDK_API int SDK_write(int fd, char* buffer, int count);
PA2XSDK_API int SDK_writeln(int fd, char* buffer);
PA2XSDK_API int SDK_DiskC_format(void);
PA2XSDK_API int SDK_DiskD_format(void);
PA2XSDK_API unsigned int SDK_DiskC_totalsize(void);
PA2XSDK_API unsigned int SDK_DiskD_totalsize(void);
PA2XSDK_API unsigned int SDK_DiskC_usedsize(void);
PA2XSDK_API unsigned int SDK_DiskD_usedsize(void);
PA2XSDK_API unsigned int SDK_DiskC_freesize(void);
PA2XSDK_API unsigned int SDK_DiskD_freesize(void);
PA2XSDK_API int SDK_getDirNum(char *pssPath);
PA2XSDK_API int SDK_getFileNum(char *pssPath);
PA2XSDK_API int SDK_getDirList(char *pssPath, char *pssBuffer);
PA2XSDK_API int SDK_getFileList(char *pssPath, char *pssBuffer);
PA2XSDK_API int SDK__fclose(_TFILE* file_pointer);
PA2XSDK_API void SDK__fcloseAll(void);
PA2XSDK_API int SDK__fseek(_TFILE *file_pointer, long offset, int origin);
PA2XSDK_API unsigned int SDK__filelength(_TFILE* file_pointer);
PA2XSDK_API _TFILE* SDK__fopen(const char*filename, const char *access_mode);
PA2XSDK_API unsigned int SDK__fread(const void *buffer, U32 size, U32 count, _TFILE *file_pointer);
PA2XSDK_API unsigned int SDK__fwrite(const void *buffer, U32 size, U32 count, _TFILE *file_pointer);

/***************************       DBMS         *******************************/

PA2XSDK_API int SDK_Ini_Search(_TFILE* filehd,_DBMS* F_Search, unsigned char *pusFielddlt, int record_type,
			   int record_length, int total_field_no, int total_record_no);
PA2XSDK_API int SDK_Ini_SearchAdv(_TFILE* filehd,_DBMS* F_Search, unsigned char *pusFielddlt, unsigned char*pusKeyIdx, 
			  int slKeyField_Num, int record_type, int record_length, int total_field_no, int total_record_no);

PA2XSDK_API int SDK_Close_Search(_DBMS* F_Search);
PA2XSDK_API int SDK_SearchField(_DBMS* F_Search, char* field, int search_fieldno, int recordno, int flag);
PA2XSDK_API int SDK_SearchField_GR(_DBMS* F_Search, char* field, int search_fieldno, int recordno,
				  char* R_Buffer, int flag);
PA2XSDK_API int SDK_SearchField_GF(_DBMS* F_Search, char* field, int search_fieldno, int recordno, 
				  int get_field_no, char* F_Buffer, int flag);
PA2XSDK_API int SDK_SearchMultiField_GF(_DBMS* F_Search, char* multi_field, int recordno, int get_field_no, 
					   char* F_Buffer, int flag);
PA2XSDK_API long SDK_SeekRecord(_DBMS* F_Search,int recordno);
PA2XSDK_API int SDK_GetRecordNum(_DBMS* F_Search);
PA2XSDK_API int SDK_DeleteRecord(_DBMS* F_Search,int recordnum);
PA2XSDK_API int SDK_DeleteLastRecord(_DBMS* F_Search);
PA2XSDK_API int SDK_AppendRecord(_DBMS* F_Search,char* record);
PA2XSDK_API int SDK_WriteField(_DBMS* F_Search, int recordno, int fieldno, char* field);
PA2XSDK_API int SDK_WriteRecord(_DBMS* F_Search, int recordno, char* record);
PA2XSDK_API int SDK_ReadField(_DBMS* F_Search, int recordno, int fieldno, char* buffer);
PA2XSDK_API int SDK_ReadRecord(_DBMS* F_Search, int recordno, char* buffer);

/*****************************      LED      **********************************/
PA2XSDK_API void SDK_set_led(int led, int mode, int duration);

/****************************     Keypad     **********************************/
PA2XSDK_API void SDK_clr_kb(void);
PA2XSDK_API void SDK_dis_alpha(void);
PA2XSDK_API void SDK_en_alpha(void);
PA2XSDK_API int SDK_get_alpha_enable_state(void);
PA2XSDK_API void SDK_set_alpha_mode_state(int status);
PA2XSDK_API int SDK_get_alpha_mode_state(void);

PA2XSDK_API int SDK_get_alpha_lock_state(void);

PA2XSDK_API void SDK_set_keypad_BL(BOOL bStatus);
PA2XSDK_API BOOL SDK_get_keypad_BL(void);
PA2XSDK_API void SDK_set_keypad_BL_Timer(int slTimer);
PA2XSDK_API int SDK_get_keypad_BL_Timer(void);

PA2XSDK_API int SDK_kbhit(void);
PA2XSDK_API int SDK__getchar(void);
PA2XSDK_API int SDK_GetKeyClick(void);
PA2XSDK_API void SDK_SetKeyClick(int status);

PA2XSDK_API void SDK_FNKey_Reset(void);
PA2XSDK_API char SDK_FNKey_GetState(short smKeyNum);
PA2XSDK_API char SDK_FNKey_SetUserDef(short smKeyNum, void (*pslFunction)(void));
PA2XSDK_API void SDK_Def_PKey(int nPKey, char ssDef);

PA2XSDK_API BOOL SDK__SetScanKeyPwOn(BOOL state);
PA2XSDK_API BOOL SDK__GetScanKeyPwOn(void);

///////Only for _scanf_color use/////////////////
PA2XSDK_API int SDK__scanf_color(int color, const char *format, char *pssPoint);
PA2XSDK_API int SDK__scanf_color_DefaultStr(int color, char* assDefaultStr, const char *format, char *pssPoint);

PA2XSDK_API void SDK__scanf_ctrl_ScannerStatus(BOOL bStatus);
PA2XSDK_API void SDK__scanf_ctrl_ScannerSleep(BOOL bStatus);
PA2XSDK_API void SDK__scanf_ctrl_Vibrate(BOOL bEnable);
PA2XSDK_API void SDK__scanf_ctrl_ScanWithENT(BOOL bScanEnt);
PA2XSDK_API void SDK__scanf_ctrl_AlphaKey(BOOL bAlpha);
PA2XSDK_API void SDK__scanf_ctrl_AlphaKey_Mode(int slAlphaMode);
PA2XSDK_API void SDK__scanf_ctrl_password(char ssPassWord);
PA2XSDK_API void SDK__scanf_ctrl_KeypadLock(BOOL bLock);
/////////////////////////////////////////////////

/**************************        LCD       **********************************/
PA2XSDK_API void SDK_clr_eol(void);
PA2XSDK_API void SDK_clr_rect(int left, int top, int width, int height);
PA2XSDK_API void SDK_clr_scr(void);
PA2XSDK_API void SDK_fill_rect(int left, int top, int width, int height);
PA2XSDK_API void SDK_fill_rect_color(int color, int left, int top, int width, int height);
PA2XSDK_API int SDK_Get_Cursor(void);
PA2XSDK_API void SDK_Set_Cursor(int status);
PA2XSDK_API int SDK_gotoxy(int x_position, int y_position);
PA2XSDK_API int SDK_wherex(void);
PA2XSDK_API int SDK_wherexy(int* column, int* row);
PA2XSDK_API int SDK_wherey(void);
PA2XSDK_API void SDK_lcd_backlit_Setlv(int level);
PA2XSDK_API void SDK_lcd_backlit_SetTimer(int timer);
PA2XSDK_API int SDK_lcd_backlit_Getlv(void);
PA2XSDK_API int SDK_lcd_backlit_GetTimer(void);
PA2XSDK_API int SDK__printf_color(int color, char *format, ...);
PA2XSDK_API int SDK__putchar(char c);
PA2XSDK_API int SDK__putchar_color(int color, char c);
PA2XSDK_API char SDK__puts(char* string);
PA2XSDK_API char SDK__puts_color(int colorindex, char* string);
PA2XSDK_API void SDK_show_image_bmp(int left, int top, int width, int height, const void *pat);

/*******************************     Font    **********************************/
PA2XSDK_API BOOL SDK_DispFont_SetFont(S32 slSelFont, const char *filename);
PA2XSDK_API BOOL SDK_DispFont_GetFontInfo(S32 slSelFont, S32* slType, S32* slWidth, S32* slHeight);

/****************************     TextBlock    ********************************/
PA2XSDK_API BOOL SDK_DefineTextBlock(S32 slBlockNo,S32 slSelFont,S32 slBGType,U32* ulBGData,S32 slColumn,S32 slRow,S32 slXPos,S32 slYPos);
PA2XSDK_API BOOL SDK_SetTextBlock(S32 slBlockNo,BOOL bSF);
PA2XSDK_API void SDK_ResetTextBlock(S32 slBlockNo);
PA2XSDK_API POINT SDK_PrintTextBlock(S32 slBlockNo, S32 slColumn, S32 slRow, char* string, U32 ulFontColor);
PA2XSDK_API POINT SDK_GetTextBlockCur(S32 slBlockNo);
PA2XSDK_API void SDK_SetTextBlockCur(S32 slBlockNo,S32 slColumn,S32 slRow);
PA2XSDK_API void SDK_ShowTextBlockCursor(S32 slBlockNo, BOOL bShow, S32 slType);
PA2XSDK_API void SDK_TextBlock_SetBGColor(S32 slColor);
PA2XSDK_API BOOL SDK_TextBlock_SetBGImage(S8* pssPath);
PA2XSDK_API BOOL SDK_SwitchTextBlock(S32 slBlockNo);
PA2XSDK_API void SDK_SetTextBlockMode(int slMode);
PA2XSDK_API int SDK_GetTextBlockMode(void);

/**********************     Communication Ports     ***************************/
PA2XSDK_API void SDK_clear_com(int port);
PA2XSDK_API int SDK_close_com(int port);
PA2XSDK_API int SDK_com_cts(int port);
PA2XSDK_API int SDK_com_eot(int port);
PA2XSDK_API int SDK_com_overrun(int port);
PA2XSDK_API void SDK_com_rts(int port, int val);
PA2XSDK_API int SDK_nwrite_com(int port, char *s, int count);
PA2XSDK_API int SDK_open_com(int com_port, int setting);
PA2XSDK_API int SDK_read_com(int port, char *c);
PA2XSDK_API int SDK_write_com(int port, char *s);

PA2XSDK_API void SDK_USB_Open(void);
PA2XSDK_API void SDK_USB_Close(void);
PA2XSDK_API int SDK_USB_Read(unsigned char *rbuf, unsigned int rLength);
PA2XSDK_API void SDK_USB_Write(unsigned char *wbuf, unsigned int wLength);

/**********************         Remote Link          ***************************/
PA2XSDK_API void SDK_SetRemoteBaud(int slBaud);
PA2XSDK_API int SDK_GetRemoteBaud(void);

PA2XSDK_API void SDK_SetRemoteInterface(int slInterface);
PA2XSDK_API int SDK_GetRemoteInterface(void);

PA2XSDK_API void SDK_RemoteLink(void);
PA2XSDK_API void SDK_RemoteLink_RealTime(BOOL bStatus);

/***********************           System           ****************************/
PA2XSDK_API void SDK_SysSuspend(void);
PA2XSDK_API void SDK_SysDelay(unsigned int ulTime);
PA2XSDK_API void SDK_SetPowerOnState(int slStatus);
PA2XSDK_API int SDK_GetPowerOnState(void);
PA2XSDK_API void SDK_SetAutoPWOff(int slTimer);
PA2XSDK_API int SDK_GetAutoPWOff(void);
PA2XSDK_API void SDK_SetStatusBAR(int slStatus);
PA2XSDK_API int SDK_GetStatusBAR(void);
PA2XSDK_API void SDK_SN_Get(char *pssSNBuffer);
PA2XSDK_API void SDK_BIOS_SetDefault(void);
PA2XSDK_API BOOL SDK_Check_AID(char* pssUser, char* pssPassword);

/***********************           Memory           ****************************/
PA2XSDK_API void SDK_Tfree(void *mem_address);
PA2XSDK_API void* SDK_Tmalloc(U32 num_bytes);

PA2XSDK_API int SDK_TotalHeapSize(void);
PA2XSDK_API int SDK_UsedHeapSize(void);
PA2XSDK_API int SDK_FreeHeapSize(void);

/***********************           Vibrate          ****************************/
PA2XSDK_API void SDK_off_vibrator(void);
PA2XSDK_API void SDK_on_vibrator(void);
PA2XSDK_API void SDK_set_vibrator_timer(unsigned char usTimer);
PA2XSDK_API unsigned char SDK_get_vibrator_timer(void);

/***************************       Others        *******************************/
PA2XSDK_API void SDK_prc_menu_color(MENU_COLOR *menu);
PA2XSDK_API void SDK_prc_menu_Set_SelectWithEnt(BOOL bENT);
PA2XSDK_API BOOL SDK_prc_menu_Get_SelectWithEnt(void);
/***************************    For Simulator    *******************************/
PA2XSDK_API void SDK_CopyFileToTerminal(char *pssPCFileName, char *pssPDTFileName);
PA2XSDK_API void SDK_BackupDataFiletoPC(char *pTerminalFile, char *pPCFileName);

/***************************   Data Conversion   *******************************/
PA2XSDK_API char * SDK__itoa(int value, char *string, int radix);
PA2XSDK_API char * SDK__ltoa(long value, char *string, int radix);
PA2XSDK_API char * SDK__ultoa(unsigned long value, char *string, int radix);

/***************************   Global variable & array   *******************************/
PA2XSDK_API int *SDK_fErrorCode;

PA2XSDK_API volatile unsigned long *SDK_sys_msec;
PA2XSDK_API volatile unsigned long *SDK_sys_sec;

PA2XSDK_API int  *SDK_CodeLen;
PA2XSDK_API char *SDK_CodeBuf;
PA2XSDK_API char *SDK_FullCodeBuf;
PA2XSDK_API char *SDK_CodeID;
PA2XSDK_API char *SDK_CodeName;
PA2XSDK_API char *SDK_Preamble;
PA2XSDK_API char *SDK_Postamble;
PA2XSDK_API char *SDK_Terminator;


