//Others.c


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "SDK.H"

///////////////////// 0. MAIN MENU  ////////////////////////
void Func_IN(void);
void Func_OUT(void);
void Func_LOOKUP(void);
void Func_SEND(void);

MENU_ENTRY_COLOR Menu_IN = {0,1,"1.Stock Import",Func_IN,0};
MENU_ENTRY_COLOR Menu_OUT = {0,2,"2.Stock Export",Func_OUT,0};
MENU_ENTRY_COLOR Menu_LOOKUP = {0,3,"3.Data Lookup",Func_LOOKUP,0};
MENU_ENTRY_COLOR Menu_SEND = {0,4,"4.Remote Link",Func_SEND,0};

///////////////////// PROGRAM ENTRY POINT ///////////////////
void Application_Main(void)
{
	MENU_COLOR MAIN_Menu = {4,1,0,"  ARGOX SAMPLE",COLOR_BROWN, COLOR_BLUE, COLOR_LIGHTBLUE,{&Menu_IN,&Menu_OUT,&Menu_LOOKUP,&Menu_SEND}};
//	int LIGHTBLUE = 0xff8080;
	U32 LIGHTBLUE = 0xff8080;

	/////For Simulator////
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 3\\Fonts\\Font18.cft", "D:\\Fonts\\Font18.cft");
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 3\\Lookup\\Lookup.txt", "D:\\Lookup\\Lookup.txt");
	CopyFileToTerminal("..\\..\\..\\Sample Code(For Terminal)\\Sample 3\\Data\\DATA.txt", "C:\\DATA\\DATA.txt");
	//////////////////////

    DispFont_SetFont(2,"D:\\Fonts\\Font18.cft");
	DefineTextBlock(1, 2, TYPE_ORIGINAL, &LIGHTBLUE, 18, 12, 0, 0);
	SetTextBlock(1, 1);

	while(1)
	{
		prc_menu_color(&MAIN_Menu);
	}
}

//////////// SEARCH DEFINITION //////////////
#define LOOKUP_SEARCH_TYPE				1
#define LOOKUP_SEARCH_FIELDDLT          ","
#define LOOKUP_SEARCH_LENGTH			0
#define LOOKUP_SEARCH_TOTALFIELDNO		2
#define LOOKUP_SEARCH_TOTALRECORDNO		-1

#define DATA_SEARCH_TYPE			1
#define DATA_SEARCH_FIELDDLT			","
#define DATA_SEARCH_LENGTH				0
#define DATA_SEARCH_TOTALFIELDNO		2
#define DATA_SEARCH_TOTALRECORDNO		-1

//////////////Lookup File Open///////////////////////////
void Lookup_Open(_TFILE *fp_Lookup);
void Lookup_Open(_TFILE *fp_Lookup)
{

	if (fp_Lookup == NULL)
	{
		gotoxy(0,1);
		_printf_color(COLOR_BLACK, "No Lookup File!");

		gotoxy(0,8);
		_printf_color(COLOR_BLACK, "Any key return....");
		while(_getchar() == 0);
		Set_Cursor(0);
		return;
	}
}

//////////////Lookup Ini_Search///////////////////////////
void Lookup_Ini_Search(int ini_lookup);
void Lookup_Ini_Search(int ini_lookup)
{
	if (ini_lookup == -1)
	{
		gotoxy(0,1);
		clr_eol();
		_printf_color(0, "Lookup Ini_Search error!");
		while(_getchar() == 0);
		return;
	}
}
///////////////Data File Open////////////////////////////
void DataFile_Open(_TFILE *fp_Data);
void DataFile_Open(_TFILE *fp_Data)
{	

	if (fp_Data == NULL)
	{
		fp_Data = _fopen("C:\\Data\\data.txt", "w+");
	}
	if (fp_Data == NULL)
	{
		DiskC_format();
		fp_Data = _fopen("C:\\Data\\data.txt", "w+");
	}

	if (fp_Data == NULL)
	{
		gotoxy(0,1);
		_printf_color(COLOR_BLACK, "No Data File!");

		gotoxy(0,8);
		_printf_color(COLOR_BLACK, "Any key return....");
		while(_getchar() == 0);
		Set_Cursor(0);
		return;
	}
}

//////////////Data File Ini_Search///////////////////////////
void Data_Ini_Search(int ini_data);
void Data_Ini_Search(int ini_data)
{
	if (ini_data == -1)
	{
		gotoxy(0,1);
		clr_eol();
		_printf_color(0, "Data Ini_Search error!");
		while(_getchar() == 0);
		return;
	}
}

///////////////DBMS Close////////////////////////////
void DBMS_Close(_TFILE *fp_Lookup, _TFILE *fp_Data, _DBMS stLookupSearch,_DBMS stDataSearch);
void DBMS_Close(_TFILE *fp_Lookup, _TFILE *fp_Data, _DBMS stLookupSearch,_DBMS stDataSearch)
{
	_fclose(fp_Lookup);
	_fclose(fp_Data);
	Close_Search(&stLookupSearch);
	Close_Search(&stDataSearch);	
	return;
}

///////////////////// 1. STOCK_IN  ////////////////////////
void Func_IN(void)
{
	_TFILE *fp_Lookup,*fp_Data;
	_DBMS stLookupSearch,stDataSearch;
	int slGetSCAN, slGetRec, ini_lookup,ini_data;
	int slQty;
	char assSN[12], assModelName[10];
	char assQty[12], assQty_Input[12], assQty_Add[12];
	char assAppendRec[40];
	fp_Data = _fopen("C:\\Data\\data.txt", "r+");
	fp_Lookup = _fopen("D:\\Lookup\\Lookup.txt", "r");

    Lookup_Open(fp_Lookup);
	DataFile_Open(fp_Data);
    ini_lookup=Ini_Search(fp_Lookup, &stLookupSearch, LOOKUP_SEARCH_FIELDDLT, LOOKUP_SEARCH_TYPE, LOOKUP_SEARCH_LENGTH, LOOKUP_SEARCH_TOTALFIELDNO, LOOKUP_SEARCH_TOTALRECORDNO) ;
	Lookup_Ini_Search(ini_lookup);
	ini_data=Ini_Search(fp_Data, &stDataSearch, DATA_SEARCH_FIELDDLT, DATA_SEARCH_TYPE, DATA_SEARCH_LENGTH, DATA_SEARCH_TOTALFIELDNO, DATA_SEARCH_TOTALRECORDNO);
	Data_Ini_Search(ini_data);


	while(1)
	{
		memset(assSN, 0x0, 12);
		memset(assModelName, 0x0, 10);

		clr_scr();
		_printf_color(COLOR_BROWN, "  STOCK IMPORT");

		gotoxy(0,1);
		_printf_color(COLOR_BLACK, "SCAN BARCODE:");

		gotoxy(0,2);
		_scanf_ctrl_ScannerStatus(TRUE);
		_scanf_ctrl_ScanWithENT(TRUE);
		_scanf_ctrl_Vibrate(TRUE);
		_scanf_ctrl_AlphaKey(FALSE);
		_scanf_ctrl_AlphaKey_Mode(ALPHA_123);
		_scanf_ctrl_password(0);
		_scanf_ctrl_KeypadLock(FALSE);

		Set_Cursor(2);
		slGetSCAN = _scanf_color(COLOR_BLACK, "%12s", assSN);

		if (slGetSCAN == 0)
			continue;
		else if (slGetSCAN == 0xFF) 
			
		{
			DBMS_Close(fp_Lookup, fp_Data, stLookupSearch,stDataSearch);
			return;
		}
		else
		{
			if ((slGetRec = SearchField(&stLookupSearch, assSN, 0, 0, FORWARD)) != -1)
			{		

				ReadField(&stLookupSearch, slGetRec, 1, assModelName);

				gotoxy(0,3);
				_printf_color(COLOR_BLACK,"MODEL NAME:%s" ,assModelName);

				if ((slGetRec = SearchField_GF(&stDataSearch, assSN, 0, 0, 1, assQty, FORWARD)) != -1)
				{
					gotoxy(0,4);
					_printf_color(COLOR_BLACK, "Stock Q'ty:%2s", assQty);
				}
				else
				{
					gotoxy(0,4);
					_printf_color(COLOR_BLACK, "Stock Q'ty:0");
				} 

				while(1)
				{
					memset(assQty_Input, 0x0, 12);
					gotoxy(0,5);

					clr_eol();
					Set_Cursor(2);
					_printf_color(COLOR_BLACK, "Import Q'ty:");
					slGetSCAN = _scanf_color(COLOR_BLACK, "%5s", assQty_Input);
					Set_Cursor(0);

					if (slGetSCAN == 0)
						continue;
					else if (slGetSCAN == 0xFF)
					{						
						break;
					}
					else
					{
						gotoxy(0,7);
						clr_eol();
						memset(assQty_Add, 0x0, 12);
						slQty = atoi(assQty_Input) + atoi(assQty);

						if (slQty > 99999)
						{
							slQty = 99999;
							_printf_color(COLOR_RED, "Stock Overloaded!");
							SysDelay(1000);
							continue;
						}

						__itoa(slQty, assQty_Add, 10);

						gotoxy(0,6);
						clr_eol();
						_printf_color(COLOR_BLACK, "Total Q'ty:%s", assQty_Add);

						memset(assAppendRec, 0, 40);
						strcat(assAppendRec, assSN);
						strcat(assAppendRec, ",");
						strcat(assAppendRec, assQty_Add);

						if (slGetRec == -1)
						{
							AppendRecord(&stDataSearch, assAppendRec);
						}
						else
						{
							WriteRecord(&stDataSearch, slGetRec, assAppendRec);
						}

						SysDelay(1500);
						break;
					}
				}				
				continue;
			}
			else
			{
				_printf_color(COLOR_RED, "\nInput Error!!");
				SysDelay(1000);
				continue;
			}
		}
	}
}

///////////////////// 2. STOCK_OUT  ////////////////////////
void Func_OUT(void)
{
	_TFILE *fp_Lookup, *fp_Data;
	_DBMS stLookupSearch, stDataSearch;

	int slGetSCAN, slGetRec,ini_lookup,ini_data;
	int slQty;
	char assSN[12], assModelName[10];
	char assQty[12], assQty_Input[12], assQty_Subs[12]; 
	char assAppendRec[40];

	fp_Lookup = _fopen("D:\\Lookup\\Lookup.txt", "r");
	fp_Data = _fopen("C:\\Data\\data.txt", "r+");

    Lookup_Open(fp_Lookup);
	DataFile_Open(fp_Data);
    ini_lookup=Ini_Search(fp_Lookup, &stLookupSearch, LOOKUP_SEARCH_FIELDDLT, LOOKUP_SEARCH_TYPE, LOOKUP_SEARCH_LENGTH, LOOKUP_SEARCH_TOTALFIELDNO, LOOKUP_SEARCH_TOTALRECORDNO) ;
	Lookup_Ini_Search(ini_lookup);
	ini_data=Ini_Search(fp_Data, &stDataSearch, DATA_SEARCH_FIELDDLT, DATA_SEARCH_TYPE, DATA_SEARCH_LENGTH, DATA_SEARCH_TOTALFIELDNO, DATA_SEARCH_TOTALRECORDNO);
	Data_Ini_Search(ini_data);

	while(1)
	{
		memset(assSN, 0x0, 12);
		memset(assModelName, 0x0, 10);
		clr_scr();
		_printf_color(COLOR_BROWN, "  STOCK EXPORT");

		gotoxy(0,1);
		_printf_color(COLOR_BLACK, "SCAN BARCODE:");

		gotoxy(0,2);
		_scanf_ctrl_ScannerStatus(TRUE);
		_scanf_ctrl_ScanWithENT(TRUE);
		_scanf_ctrl_Vibrate(TRUE);
		_scanf_ctrl_AlphaKey(FALSE);
		_scanf_ctrl_AlphaKey_Mode(ALPHA_123);
		_scanf_ctrl_password(0);
		_scanf_ctrl_KeypadLock(FALSE);

		Set_Cursor(2);
		slGetSCAN = _scanf_color(COLOR_BLACK, "%12s", assSN);


		if (slGetSCAN == 0)
			continue;
		else if (slGetSCAN == 0xFF)
		{
			DBMS_Close(fp_Lookup, fp_Data, stLookupSearch,stDataSearch);
			return;
		}
		else
		{
			if ((slGetRec = SearchField(&stLookupSearch, assSN, 0, 0, FORWARD)) != -1)
			{
				ReadField(&stLookupSearch, slGetRec, 1, assModelName);

				gotoxy(0,3);
				_printf_color(COLOR_BLACK,"MODEL NAME:%s",assModelName);

				memset(assQty, 0x0, 12);

				if ((slGetRec = SearchField_GF(&stDataSearch, assSN, 0, 0, 1, assQty, FORWARD)) != -1)
				{
					gotoxy(0,4);
					_printf_color(COLOR_BLACK, "STOCK Q'ty:%2s", assQty);
				}
				else
				{
					gotoxy(0,4);
					_printf_color(COLOR_BLACK, "STOCK Q'ty: 0");
				}

				while(1)
				{
					memset(assQty_Input, 0x0, 12);
					gotoxy(0,5);
					clr_eol();
					Set_Cursor(2);
					_printf_color(COLOR_BLACK, "EXPORT Q'ty:");
					slGetSCAN = _scanf_color(COLOR_BLACK, "%5s", assQty_Input);

					if (slGetSCAN == 0)
						continue;
					else if (slGetSCAN == 0xFF)
					{						
						break;
					}
					else
					{
						gotoxy(0,7);
						clr_eol();
						memset(assQty_Subs, 0x0, 12);
						slQty = atoi(assQty) - atoi(assQty_Input);

						if (slQty < 0)
						{
							slQty = 0;
							_printf_color(COLOR_RED, "Stock Insufficient!");
							SysDelay(1000);
							continue;
						}

						__itoa(slQty, assQty_Subs, 10);
						gotoxy(0,6);
						_printf_color(COLOR_BLACK, "TOTAL Q'ty:%2s", assQty_Subs);
						memset(assAppendRec, 0, 40);
						strcat(assAppendRec, assSN);
						strcat(assAppendRec, ",");
						strcat(assAppendRec, assQty_Subs);

						if (slGetRec == -1)
						{
							AppendRecord(&stDataSearch, assAppendRec);
						}
						else
						{
							WriteRecord(&stDataSearch, slGetRec, assAppendRec);
						}

						SysDelay(1500);
						break;
					}
				}				
				continue;
			}
			else
			{
				_printf_color(COLOR_RED, "\nInput Error!!");
				SysDelay(1000);
				continue;
			}
		}
	}
}

///////////////////// 3. LOOK_UP  ////////////////////////
void LOOKUP_SN(void);
void LOOKUP_BROWSER(void);

MENU_ENTRY_COLOR SubMenu_LOOKUP_SN		= {0, 1, "1.SEARCH by SN", LOOKUP_SN, 0};
MENU_ENTRY_COLOR SubMenu_LOOKUP_BROWSER		= {0, 2, "2.DATA BROWSE", LOOKUP_BROWSER, 0};

MENU_COLOR SubMenu_LOOKUP = {2,1,0,"   DATA LOOKUP",COLOR_BROWN, COLOR_BLUE, COLOR_LIGHTBLUE,{&SubMenu_LOOKUP_SN,&SubMenu_LOOKUP_BROWSER}};

void Func_LOOKUP(void)
{
	prc_menu_color(&SubMenu_LOOKUP);
}

//////////////////////LOOK_UP BY SN//////////////////////////////////
void LOOKUP_SN(void)
{
	_TFILE *fp_Lookup, *fp_Data;
	_DBMS stLookupSearch, stDataSearch;

	int slGetSCAN, slGetRec,ini_lookup,ini_data;
	char assSN[12], assModelName[10];
	char assQty[12];
	fp_Lookup = _fopen("D:\\Lookup\\Lookup.txt", "r");
	fp_Data = _fopen("C:\\Data\\DATA.txt", "r");

    Lookup_Open(fp_Lookup);
	DataFile_Open(fp_Data);
    ini_lookup=Ini_Search(fp_Lookup, &stLookupSearch, LOOKUP_SEARCH_FIELDDLT, LOOKUP_SEARCH_TYPE, LOOKUP_SEARCH_LENGTH, LOOKUP_SEARCH_TOTALFIELDNO, LOOKUP_SEARCH_TOTALRECORDNO) ;
	Lookup_Ini_Search(ini_lookup);
	ini_data=Ini_Search(fp_Data, &stDataSearch, DATA_SEARCH_FIELDDLT, DATA_SEARCH_TYPE, DATA_SEARCH_LENGTH, DATA_SEARCH_TOTALFIELDNO, DATA_SEARCH_TOTALRECORDNO);
	Data_Ini_Search(ini_data);

	while(1)
	{
		memset(assSN, 0x0, 12);
		memset(assModelName, 0x0, 10);

		clr_scr();
		_printf_color(COLOR_BROWN, "SEARCH by SN");

		gotoxy(0,1);
		_printf_color(COLOR_BLACK, "SCAN BARCODE:");

		gotoxy(0,2);
		_scanf_ctrl_ScannerStatus(TRUE);
		_scanf_ctrl_ScanWithENT(TRUE);
		_scanf_ctrl_Vibrate(TRUE);
		_scanf_ctrl_AlphaKey(FALSE);
		_scanf_ctrl_AlphaKey_Mode(ALPHA_123);
		_scanf_ctrl_password(0);
		_scanf_ctrl_KeypadLock(FALSE);

		Set_Cursor(2);
		slGetSCAN = _scanf_color(COLOR_BLACK, "%12s", assSN);
		if (slGetSCAN == 0)//No Input
			continue;
		else if(slGetSCAN == 0xFF)
		{
			DBMS_Close(fp_Lookup, fp_Data, stLookupSearch,stDataSearch);
			return;
		}
		else		
		{
			slGetRec = SearchField(&stLookupSearch, assSN, 0, 0, FORWARD);			

			if(slGetRec !=-1)			
			{
				ReadField(&stLookupSearch, slGetRec, 1, assModelName);
				gotoxy(0,3);
				_printf_color(COLOR_ORANGE, "MODEL NAME:%s", assModelName);
				memset(assQty, 0x0, 12);
				slGetRec = SearchField_GF(&stDataSearch, assSN, 0, 0, 1, assQty, FORWARD);
				if(slGetRec !=-1)
				{
					gotoxy(0,4);
					_printf_color(COLOR_ORANGE, "STOCK Q'ty:%s", assQty);
				}
				else
				{
					gotoxy(0,4);
					_printf_color(COLOR_BLACK, "STOCK Q'ty: 0");
				}
			}
			else
			{
				_printf_color(COLOR_RED, "\nInput Error!!");
				SysDelay(1000);
				continue;	
			}
		while(_getchar() == 0);
		}
	}
}

////////////////LOOK_UP BY BROWSING////////////////////////
void LOOKUP_BROWSER(void)
{
	_TFILE *fp;
	_TFILE *fpQty;
	_DBMS stFileSearch;
	_DBMS stQtySearch;

	int i = 0;
	char assSN[12], assModelName[10],  assQty[5];
	int slGetKey,record_num,ini_lookup,ini_data;

	clr_scr();
	fp = _fopen("D:\\Lookup\\Lookup.txt", "r");
	fpQty = _fopen("C:\\Data\\Data.txt", "r");

    Lookup_Open(fp);
	DataFile_Open(fpQty);
    ini_lookup=Ini_Search(fp, &stFileSearch, LOOKUP_SEARCH_FIELDDLT, LOOKUP_SEARCH_TYPE, LOOKUP_SEARCH_LENGTH, LOOKUP_SEARCH_TOTALFIELDNO, LOOKUP_SEARCH_TOTALRECORDNO);
	Lookup_Ini_Search(ini_lookup);
	ini_data=Ini_Search(fpQty, &stQtySearch, LOOKUP_SEARCH_FIELDDLT, LOOKUP_SEARCH_TYPE, LOOKUP_SEARCH_LENGTH, LOOKUP_SEARCH_TOTALFIELDNO, LOOKUP_SEARCH_TOTALRECORDNO);
	Data_Ini_Search(ini_data);
	record_num=GetRecordNum(&stFileSearch);

	while(1)
	{

		memset(assSN, 0x0, 12);
		memset(assModelName, 0x0, 10);
		memset(assQty, 0x0, 12);

		clr_scr();

		_printf_color(COLOR_BROWN, "DATA BROWSE(%d/%d)", i+1,record_num);
		ReadField(&stFileSearch, i, 0, assSN);
		ReadField(&stFileSearch, i, 1, assModelName);
		ReadField(&stQtySearch, i, 1, assQty);

		gotoxy(0,2);
		_printf_color(COLOR_ORANGE, "S/N:%s", assSN);
		gotoxy(0,3);
		_printf_color(COLOR_ORANGE, "MODEL NAME:%s", assModelName);
		gotoxy(0,4);
		_printf_color(COLOR_ORANGE, "Q'ty:%s", assQty);

		while(1)
		{
			slGetKey = _getchar();
			if (slGetKey == KEY_ESC)
			{
				DBMS_Close(fp, fpQty, stFileSearch,stQtySearch);
				return;
			}

			if (slGetKey == KEY_CR)
			{
				i++;
				if (i == stFileSearch.total_record_no)
					i = 0;
				break;
			}

			if (slGetKey == KEY_UP)
			{
				i++;
				if (i == stFileSearch.total_record_no)
					i = 0;
				break;
			}

			if (slGetKey == KEY_DOWN)
			{

				if(i==0)
					i= stFileSearch.total_record_no;
				i--;
				break;
			}
		}
	}	
}

///////////////////// 4.COMMUNICATION ////////////////////////
void SEND_USB(void);
void SEND_RS232(void);

MENU_ENTRY_COLOR SubMenu_SEND_USB		= {0, 1, "1.USB Port", SEND_USB, 0};
MENU_ENTRY_COLOR SubMenu_SEND_RS232		= {0, 2, "2.COM Port", SEND_RS232, 0};
MENU_COLOR SubMenu_SEND = {2,1,0,"    INTERFACE",COLOR_BROWN, COLOR_BLUE, COLOR_LIGHTBLUE,{&SubMenu_SEND_USB,&SubMenu_SEND_RS232}};

void Func_SEND(void)
{
	prc_menu_color(&SubMenu_SEND);
}

/////////////////////////////////////////
void SEND_USB(void)//USB LINK
{
	SetRemoteInterface(1);
	RemoteLink();
}

void LINK_COM(void)//RS232 LINK
{
	SetRemoteInterface(0);
	RemoteLink();
}

//////////////RS232 BAUD RATE SETTING//////////////////////////
void BaudRate_115200(void)
{
	SetRemoteBaud(0);
	gotoxy(0,1);
	_printf_color(COLOR_BROWN, "BAUD RATE:\n115200");
	SysDelay(1000);
}

void BaudRate_57600(void)
{
	SetRemoteBaud(1);
	gotoxy(0,1);
	_printf_color(COLOR_BROWN, "BAUD RATE:\n57600");
	SysDelay(1000);
}

void BaudRate_38400(void)
{
	SetRemoteBaud(2);
	gotoxy(0,1);
	_printf_color(COLOR_BROWN, "BAUD RATE:\n38400");
	SysDelay(1000);
}

void BaudRate_19200(void)
{
	SetRemoteBaud(3);
	gotoxy(0,1);
	_printf_color(COLOR_BROWN, "BAUD RATE:\n19200");
	SysDelay(1000);
}

void BaudRate_9600(void)
{
	SetRemoteBaud(4);
	gotoxy(0,1);
	_printf_color(COLOR_BROWN, "BAUD RATE:\n9600");
	SysDelay(1000);
}

MENU_ENTRY_COLOR BaudRate115200		= {0, 1, "1.115200 bps", &BaudRate_115200, 0};
MENU_ENTRY_COLOR BaudRate57600		= {0, 2, "2.57600 bps", &BaudRate_57600, 0};
MENU_ENTRY_COLOR BaudRate38400		= {0, 3, "3.38400 bps", &BaudRate_38400, 0};
MENU_ENTRY_COLOR BaudRate19200		= {0, 4, "4.19200 bps", &BaudRate_19200, 0};
MENU_ENTRY_COLOR BaudRate9600		= {0, 5, "5.9600 bps", &BaudRate_9600, 0};

MENU_COLOR BaudRate_Set = {5, 1, 1, "BAUD RATE", COLOR_BROWN, COLOR_BLACK, COLOR_LIGHTBLUE
						, {&BaudRate115200, &BaudRate57600, &BaudRate38400,
							&BaudRate19200, &BaudRate9600}};


void SET_BaudRate(void)
{
	prc_menu_color(&BaudRate_Set);
}

///////////////////////RS232 MAIN MENU//////////////////////////////////
MENU_ENTRY_COLOR Comm_BaudRate		= {0, 1, "1.BAUD RATE", &SET_BaudRate, 0};
MENU_ENTRY_COLOR Comm_LINK			= {0, 2, "2.CONNECT", &LINK_COM, 0};

MENU_COLOR Menu_COM = {2, 1, 0, "SET COM PORT", COLOR_BROWN, COLOR_BLACK, COLOR_LIGHTBLUE
						, {&Comm_BaudRate, &Comm_LINK}};


void SEND_RS232(void)
{
	prc_menu_color(&Menu_COM);
}

