//Define.h

#ifndef __DEFINE_H__
#define __DEFINE_H__

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************/
/*  Data Types Definition Part (ƫAwq)                    #000       */
/****************************************************************************/

#ifdef PA2XSDK_EXPORTS
#define PA2XSDK_API __declspec(dllexport)
#else
#define PA2XSDK_API __declspec(dllimport)
#endif

	typedef char			S8;		/* ss	*/
	typedef short			S16;	/* sm	*/
	typedef int				S32;	/* sl	*/
	typedef unsigned char	U8;		/* us	*/
	typedef unsigned short	U16;	/* um	*/
	typedef unsigned int	U32;	/* ul	*/

	typedef unsigned int	size_t;

#ifdef _PCHOST
	typedef int			   OS_EVENT;
	typedef unsigned char  BOOLEAN;
	typedef unsigned char  INT8U;                    // Unsigned  8 bit quantity                           //
	typedef signed   char  INT8S;                    // Signed    8 bit quantity                           //
	typedef unsigned int   INT16U;                   // Unsigned 16 bit quantity                           //
	typedef signed   int   INT16S;                   // Signed   16 bit quantity                           //
	typedef unsigned long  INT32U;                   // Unsigned 32 bit quantity                           //
	typedef signed   long  INT32S;                   // Signed   32 bit quantity                           //
	typedef float          FP32;                     // Single precision floating point                    //
	typedef double         FP64;                     // Double precision floating point                    //
#endif

#ifndef _WINDOWS_TYPE
	typedef unsigned int	BOOL;	/* ul	*/

	typedef unsigned char   BYTE;
	typedef unsigned short  WORD;
	typedef unsigned int    DWORD;
	typedef int				LONG;	

#ifdef NULL
	#undef NULL
#endif
	#define NULL 0
	#define TRUE 1
	#define FALSE 0

	#define MB_OK                 0
	#define MB_OKCANCEL           1
	#define MB_ABORTRETRYIGNORE   2
	#define MB_YESNOCANCEL        3
	#define MB_YESNO              4
	#define MB_RETRYCANCEL        5

	#define MB_ICONHAND           16
	#define MB_ICONQUESTION       32
	#define MB_ICONEXCLAMATION    48
	#define MB_ICONASTERISK       64

	#define MB_ICONINFORMATION    64
	#define MB_ICONSTOP           16

	#define MB_DEFBUTTON1         0
	#define MB_DEFBUTTON2         256
	#define MB_DEFBUTTON3         512

	#define MB_APPLMODAL          0
	#define MB_SYSTEMMODAL        4096
	#define MB_TASKMODAL          8192 

	typedef struct _POINT
	{
		S32 slX;
		S32 slY;
	}POINT;


#endif

#ifdef _PCHOST	
#define __irq
#endif

/***********************************
** The special parameter defining **
***********************************/
typedef union __U16
{
	U8 usChar[2];
	U16 umWord;
}_U16;

typedef union __S32
{
	S8 ssChar[4];
	S32 slLong;
}_S32;

typedef union __U32
{
	U8 usChar[4];
	U16 umWord[2];
	U32 ulLong;
}_U32;
	

/////////////Color Define//////////////
#define COLOR_BLACK         0x000000
#define COLOR_BLUE          0xFF0000
#define COLOR_GREEN         0x00ff00
#define COLOR_CYAN          0xffff00
#define COLOR_RED           0x0000FF
#define COLOR_MAGENTA       0x8b008b
#define COLOR_BROWN         0x2a2aa5
#define COLOR_DARKGRAY      0x404040
#define COLOR_GRAY          0x808080
#define COLOR_LIGHTGRAY     0xd3d3d3
#define COLOR_LIGHTBLUE     0xff8080
#define COLOR_LIGHTGREEN    0x80ff80
#define COLOR_LIGHTCYAN     0x80ffff
#define COLOR_LIGHTRED      0x8080ff
#define COLOR_LIGHTMAGENTA  0xff80ff
#define COLOR_YELLOW        0x00ffff
#define COLOR_ORANGE        0x008cff
#define COLOR_WHITE         0xffffff
#define COLOR_INVALID_COLOR 0xffffff      // Invalid color - more than 24 bits //
/////////////////////////////////////////
/***************************
** File Discription Block **
***************************/
typedef struct __DIRINFO
{
	S8		assFName[8];
	S8		assExtend[3];
	S8		usAttrib;
	S8		usTime[2];
	S8		usDate[2];
	U16		umStart;
	U32		ulSize;
	S8		assCR[2];
}_DIRINFO;

typedef struct __FAT16_FDB // File Discription Block
{
	S8 assName[8];			// 0  8 bytes    Name  
	S8 assExtension[3];		// 8  3 bytes    Extension  
	U8 usAttribute;			// 11  byte    Attribute (00ARSHDV) 
								// 0: unused bit 
								// A: archive bit, 
								// R: read-only bit 
								// S: system bit 
								// D: directory bit 
								// V: volume bit  

	U8 usNT;				// 12 	byte 	  NT (Reserved for WindowsNT; always 0) 
	U8 usCT_millisecond;	// 13 	byte 	  Created time; millisecond portion 
	U16 umCT_HaM;			// 14 	word 	  Created time; hour and minute 
	U16 umCT_Date;			// 16 	word 	  Created date 
	U16 umLastAccDate;		// 18 	word 	  Last accessed date 
	U16 umExtAttribute;		// 20 	word 	  Extended Attribute  (reserved for OS/2; always 0) 

	U16 umTime;				// 22  word    Time  
	U16 umDate;				// 24  word    Date  
	U16 umCluster;			// 26  word    Cluster (desc. below)  
	U32 ulFileSize;			// 28  dword    File Size  
}_FAT16_FDB;

#define MAX_PATHLEN 80

typedef struct __FS_FILE
{
	S8			assPath[MAX_PATHLEN];	// ɮ׸|
	_FAT16_FDB	*pFDB;		// ɮ DIR Table}
	S8			*pssFileHead;

	S32			slDiskNum;
	S32			slMemcpyType;
	U32			ulFileSize;			// ɮץثe Size
	U32			Currentposition;	
	U16			umAccessMode;

}_FS_FILE;
typedef	_FS_FILE	_TFILE;
typedef	_FS_FILE	FFILE;

//////////////////

#ifdef __cplusplus
}
#endif

#endif ///*__DEFINE_H__*/
